using System;
using System.Collections;

using Server.Network;

namespace Server.ContextMenus
{
	public class ContextMenu
	{
		public ContextMenu(Mobile from, object target) : base()
		{
			ArrayList list1;
			int num1;
			this.m_From = from;
			this.m_Target = target;
			list1 = new ArrayList();
			if ((target as Mobile) != null)
			{
				((Mobile) target).GetContextMenuEntries(from, list1);
 
			}
			else
			{
					if ((target as Item) != null)
			  {
				  ((Item) target).GetContextMenuEntries(from, list1);
 
			  }
 
			}
			this.m_Entries = ((ContextMenuEntry[]) list1.ToArray(typeof(ContextMenuEntry)));
			for (num1 = 0; (num1 < this.m_Entries.Length); num1 = (num1 + 1))
			{
				this.m_Entries[num1].Owner = this;
 
			}
 
		} 

		public ContextMenuEntry[] Entries { 
			get
			{
				return this.m_Entries;
			}
		}

		public Mobile From { 
			get
			{
				return this.m_From;
			}
		}

		public object Target { 
			get
			{
				return this.m_Target;
			}
		}

		private ContextMenuEntry[] m_Entries;
		private Mobile m_From;
		private object m_Target;
	}
 
	public class ContextMenuEntry
	{
		public ContextMenuEntry(int number) : this(number, -1)
		{
		}

		public ContextMenuEntry(int number, int range) : base()
		{
			this.m_Number = number;
			this.m_Range = range;
			this.m_Enabled = true;
			this.m_Color = 65535;
		} 

		public virtual void OnClick()
		{
		}

		public int Color { 
			get
			{
				return this.m_Color;
			}
			set
			{
				this.m_Color = value;
			}
		}

		public bool Enabled { 
			get
			{
				return this.m_Enabled;
			}
			set
			{
				this.m_Enabled = value;
			}
		}

		public CMEFlags Flags 
		{ 
			get
			{
				return this.m_Flags;
			}
			set
			{
				this.m_Flags = value;
			}
		}

		public int Number 
		{ 
			get
			{
				return this.m_Number;
			}
			set
			{
				this.m_Number = value;
			}
		}

		public ContextMenu Owner 
		{ 
			get
			{
				return this.m_Owner;
			}
			set
			{
				this.m_Owner = value;
			}
		}

		public int Range 
		{ 
			get
			{
				return this.m_Range;
			}
			set
			{
				this.m_Range = value;
			}
		}
		
		private int m_Color;
		private bool m_Enabled;
		private CMEFlags m_Flags;
		private int m_Number;
		private ContextMenu m_Owner;
		private int m_Range;
	}
 
	public class OpenBackpackEntry : ContextMenuEntry
	{
		public OpenBackpackEntry(Mobile m) : base(6145)
		{
			this.m_Mobile = m;
		}

		public override void OnClick()
		{
			this.m_Mobile.Use(this.m_Mobile.Backpack);
		}

		private Mobile m_Mobile;
	}
 
	public class PaperdollEntry : ContextMenuEntry
	{
		public PaperdollEntry(Mobile m) : base(6123, 18)
		{
		}

		public override void OnClick()
		{
			if (this.m_Mobile.CanPaperdollBeOpenedBy(base.Owner.From))
			{
				this.m_Mobile.DisplayPaperdollTo(base.Owner.From);
 
			}
		}

		private Mobile m_Mobile;
	}
}