using System;
using System.Collections;

using Server;

namespace Server.Guilds
{
	public enum GuildType
	{
		Regular = 0,
		Chaos = 1,
		Order = 2,
	}

	public abstract class BaseGuild
	{
		public BaseGuild() : base()
		{
			BaseGuild.m_NextID = (BaseGuild.m_NextID + 1);
			this.m_Id = BaseGuild.m_NextID;
			BaseGuild.m_GuildList.Add(this.m_Id, this);
		}

		public BaseGuild(int Id) : base()
		{
			this.m_Id = Id;
			BaseGuild.m_GuildList.Add(this.m_Id, this);
			if ((this.m_Id + 1) > BaseGuild.m_NextID)
			{
				BaseGuild.m_NextID = (this.m_Id + 1);
			}
		}

		public abstract void Deserialize(GenericReader reader);

		public static BaseGuild Find(int id)
		{
				return ((BaseGuild) BaseGuild.m_GuildList[id]); 
		} 

		public static BaseGuild FindByAbbrev(string abbr)
		{
				BaseGuild guild1;
			BaseGuild guild2;
			IEnumerator enumerator1;
			IDisposable disposable1;
			enumerator1 = BaseGuild.m_GuildList.Values.GetEnumerator();
			try
			{
				while (enumerator1.MoveNext())
				{
					guild1 = ((BaseGuild) enumerator1.Current);
					if (guild1.Abbreviation == abbr)
					{
						guild2 = guild1;
						goto L_004D;
 
					}
 
				}
 
			}
			finally
			{
				disposable1 = (enumerator1 as IDisposable);
				if (disposable1 != null)
				{
					disposable1.Dispose();
 
				}
 
			}
			return null; 
			L_004D:
				return guild2; 
		} 

		public static BaseGuild FindByName(string name)
		{
				BaseGuild guild1;
			BaseGuild guild2;
			IEnumerator enumerator1;
			IDisposable disposable1;
			enumerator1 = BaseGuild.m_GuildList.Values.GetEnumerator();
			try
			{
				while (enumerator1.MoveNext())
				{
					guild1 = ((BaseGuild) enumerator1.Current);
					if (guild1.Name == name)
					{
						guild2 = guild1;
						goto L_004D;
 
					}
 
				}
 
			}
			finally
			{
				disposable1 = (enumerator1 as IDisposable);
				if (disposable1 != null)
				{
					disposable1.Dispose();
 
				}
 
			}
			return null; 
			L_004D:
				return guild2; 
		} 

		public abstract void OnDelete(Mobile mob);
		
		public static BaseGuild[] Search(string find)
		{
			string[] array1;
			ArrayList list1;
			BaseGuild guild1;
			bool flag1;
			string text1;
			int num1;
			char[] array2;
			IEnumerator enumerator1;
			IDisposable disposable1;
			array2 = new char[1];
			array2[0] = ' ';
			array1 = find.ToLower().Split(array2);
			list1 = new ArrayList();
			enumerator1 = BaseGuild.m_GuildList.Values.GetEnumerator();
			try
			{
				goto L_0080;
 
			L_0035:
				guild1 = ((BaseGuild) enumerator1.Current);
				flag1 = true;
				text1 = guild1.Name.ToLower();
				for (num1 = 0; (num1 < array1.Length); num1 = (num1 + 1))
				{
					if (text1.IndexOf(array1[num1]) == -1)
					{
						flag1 = false;
						goto L_0075;
 
					}
 
				}
 
			L_0075:
				if (flag1)
				{
					list1.Add(guild1);
 
				}
 
			L_0080:
				if (enumerator1.MoveNext())
				{
					goto L_0035;
 
				}
 
			}
			finally
			{
				disposable1 = (enumerator1 as IDisposable);
				if (disposable1 != null)
				{
					disposable1.Dispose();
 
				}
 
			}
			return ((BaseGuild[]) list1.ToArray(typeof(BaseGuild))); 
		}
		
		public abstract void Serialize(GenericWriter writer);
		
		public abstract string Abbreviation { get; set; }
		public abstract bool Disbanded { get; }

		public int Id { 
			get
			{
				return this.m_Id;
			}
		}

		public static Hashtable List 
		{ 
			get
			{
				return BaseGuild.m_GuildList;
			}
		}

		public abstract string Name { get; set; }
		public abstract GuildType Type { get; set; }

		private static Hashtable m_GuildList = new Hashtable();
		private int m_Id;
		private static int m_NextID = 1;
	}
}