using System;

namespace Server
{
	public struct ItemData
	{
		public ItemData(string name, TileFlag flags, int weight, int quality, int quantity, int value, int height)
		{
			this.m_Name = name;
			this.m_Flags = flags;
			this.m_Weight = ((byte) weight);
			this.m_Quality = ((byte) quality);
			this.m_Quantity = ((byte) quantity);
			this.m_Value = ((byte) value);
			this.m_Height = ((byte) height);
		} 

		public bool Bridge 
		{ 
			get
			{
				return ((this.m_Flags & TileFlag.Bridge) != 0); 
			}
			set
			{
				if (value)
				{
					this.m_Flags = (this.m_Flags | TileFlag.Bridge);
					return; 
				}
				//TRF this.m_Flags = (this.m_Flags & -1025);
				this.m_Flags = (this.m_Flags & ~TileFlag.Bridge);
			}
		}

		public int CalcHeight { 
			get
			{
				if ((this.m_Flags & TileFlag.Bridge) != 0)
				{
					return (this.m_Height / 2); 
				}
				return this.m_Height;
			}
		}

		public TileFlag Flags 
		{ 
			get
			{
				return this.m_Flags;
			}
			set
			{
				this.m_Flags = value;
			}
		}

		public int Height 
		{ 
			get
			{
				return this.m_Height;
			}
			set
			{
				this.m_Height = ((byte) value);
			}
		}

		public bool Impassable 
		{ 
			get
			{
				return ((this.m_Flags & TileFlag.Impassable) != 0); 
			}
			set
			{
				if (value)
				{
					this.m_Flags = (this.m_Flags | TileFlag.Impassable);
					return; 
				}
				//TRF this.m_Flags = (this.m_Flags & -65);
				this.m_Flags = (this.m_Flags & ~TileFlag.Impassable);
			}
		}

		public string Name 
		{ 
			get
			{
				return this.m_Name;
			}
			set
			{
				this.m_Name = value;
			}
		}

		public int Quality 
		{ 
			get
			{
				return this.m_Quality;
			}
			set
			{
				this.m_Quality = ((byte) value);
			}
		}

		public int Quantity 
		{ 
			get
			{
				return this.m_Quantity;
			}
			set
			{
				this.m_Quantity = ((byte) value);
			}
		}

		public bool Surface 
		{ 
			get
			{
				return ((this.m_Flags & TileFlag.Surface) != 0);
			}
			set
			{
				if (value)
				{
					this.m_Flags = (this.m_Flags | TileFlag.Surface);
					return; 
				}
				//TRF this.m_Flags = (this.m_Flags & -513);
				this.m_Flags = (this.m_Flags & ~TileFlag.Surface);
			}
		}

		public int Value 
		{ 
			get
			{
				return this.m_Value;
			}
			set
			{
				this.m_Value = ((byte) value);
			}
		}

		public int Weight 
		{ 
			get
			{
				return this.m_Weight;
			}
			set
			{
				this.m_Weight = ((byte) value);
			}
		}
		
		private TileFlag m_Flags;
		private byte m_Height;
		private string m_Name;
		private byte m_Quality;
		private byte m_Quantity;
		private byte m_Value;
		private byte m_Weight;
	}
}