using System;
using System.Collections;

namespace Server.Mobiles
{
	public interface IMount
	{
		Mobile Rider { get; set; }
	}
 
	public interface IMountItem
	{
		IMount Mount { get; }
	}
 
	public class BuyItemResponse
	{
		public BuyItemResponse(Serial serial, int amount) : base()
		{
			this.m_Serial = serial;
			this.m_Amount = amount;
		}

		public int Amount { 
			get
			{
				return this.m_Amount;
			}
		}

		public Serial Serial { 
			get
			{
				return this.m_Serial;
			}
		}
		
		private int m_Amount;
		private Serial m_Serial;
	}
 
	public class BuyItemState
	{
		public BuyItemState(string name, Serial cont, Serial serial, int price, int amount, int itemID, int hue) : base()
		{
			this.m_Desc = name;
			this.m_ContSer = cont;
			this.m_MySer = serial;
			this.m_Price = price;
			this.m_Amount = amount;
			this.m_ItemID = itemID;
			this.m_Hue = hue;
		} 
		
		public int Amount { 
			get
			{
				return this.m_Amount;
			}
		}

		public Serial ContainerSerial 
		{ 
			get
			{
				return this.m_ContSer;
			}
		}

		public string Description 
		{ 
			get
			{
				return this.m_Desc;
			}
		}

		public int Hue 
		{ 
			get
			{
				return this.m_Hue;
			}
		}

		public int ItemID 
		{ 
			get
			{
				return this.m_ItemID;
			}
		}

		public Serial MySerial 
		{ 
			get
			{
				return this.m_MySer;
			}
		}

		public int Price 
		{ 
			get
			{
				return this.m_Price;
			}
		}
		
		private int m_Amount;
		private Serial m_ContSer;
		private string m_Desc;
		private int m_Hue;
		private int m_ItemID;
		private Serial m_MySer;
		private int m_Price;
	}
 
	public class BuyItemStateComparer : IComparer
	{
		public BuyItemStateComparer() : base()
		{
		}

		public int Compare(object l, object r)
		{
				Serial serial1;
			if ((l == null) && (r == null))
			{
				return 0; 
			}
			if (l == null)
			{
				return -1; 
			}
			if (r == null)
			{
				return 1; 
			}
			serial1 = ((BuyItemState) l).MySerial;
			return serial1.CompareTo(((BuyItemState) r).MySerial); 
		} 
	}
 
	public class SellItemResponse
	{
		public SellItemResponse(Item i, int amount) : base()
		{
			this.m_Item = i;
			this.m_Amount = amount;
		}

		public int Amount { 
			get
			{
				return this.m_Amount;
			}
		}

		public Item Item { 
			get
			{
				return this.m_Item;
			}
		}
		
		private int m_Amount;
		private Item m_Item;
	}
 
	public class SellItemState
	{
		public SellItemState(Item item, int price, string name) : base()
		{
			this.m_Item = item;
			this.m_Price = price;
			this.m_Name = name;
		}

		public Item Item { 
			get
			{
				return this.m_Item;
			}
		}

		public string Name { 
			get
			{
				return this.m_Name;
			}
		}

		public int Price { 
			get
			{
				return this.m_Price;
			}
		}
		
		private Item m_Item;
		private string m_Name;
		private int m_Price;
	}
}