using System;

namespace Server.Movement
{
	public interface IMovementImpl
	{
		bool CheckMovement(Mobile m, Direction d, ref int newZ);
		bool CheckMovement(Mobile m, Map map, Point3D loc, Direction d, ref int newZ);
	}

	public class Movement
	{
		public Movement() : base()
		{
		}


		public static bool CheckMovement(Mobile m, Direction d, ref int newZ)
		{
			if (Movement.m_Impl != null)
			{
				return Movement.m_Impl.CheckMovement(m, d, newZ); 
			}
			newZ = m.Z;
			return false; 
		} 

		public static bool CheckMovement(Mobile m, Map map, Point3D loc, Direction d, ref int newZ)
		{
			if (Movement.m_Impl != null)
			{
				return Movement.m_Impl.CheckMovement(m, map, loc, d, newZ); 
			}
			newZ = m.Z;
			return false; 
		} 

		public static void Offset(Direction d, ref int x, ref int y)
		{
				Direction direction1;
			direction1 = (d & 7);
			switch (direction1)
			{
				case 0:
				{
					y = (y - 1);
					return; 
				}
				case 1:
				{
					x = (x + 1);
					y = (y - 1);
					return; 
				}
				case 2:
				{
  
					L_0054:
						x = (x - 1);
					y = (y + 1);
					return; 
				}
				case 3:
				{
					x = (x + 1);
					y = (y + 1);
					return; 
				}
				case 4:
				{
					y = (y + 1);
					return; 
				}
				case 5:
				{
					goto L_0054;
 
				}
				case 6:
				{
  
					L_006E:
						x = (x - 1);
					y = (y - 1);
					return; 
				}
				case 7:
				{
					goto L_006E;
 
				}
 
			}
 
		}

		public static IMovementImpl Impl 
		{ 
			get
			{
				return Movement.m_Impl;
			}
			set
			{
				Movement.m_Impl = value;
			}
		}
		
		private static IMovementImpl m_Impl;
	}
}