using System;
using System.IO;

namespace Server
{
	public sealed class MultiComponentList
	{
		private MultiComponentList() : base()
		{
			//TRF this.m_Tiles = new Tile[][][0];
			this.m_Tiles = new Tile[0][][];
			this.m_List = new MultiTileEntry[0];
		}

		public MultiComponentList(BinaryReader reader, int count) : base()
		{
			MultiTileEntry[] array1;
			int num1;
			MultiTileEntry entry1;
			TileList[][] array2;
			int num2;
			int num3;
			int num4;
			int num5;
			int num6;
			int num7;
			int num8;
			MultiTileEntry[] array3;
			array3 = new MultiTileEntry[count];
			this.m_List = new MultiTileEntry[count];
			array1 = array3;
			for (num1 = 0; (num1 < count); num1 = (num1 + 1))
			{
				array1[num1].m_ItemID = reader.ReadInt16();
				array1[num1].m_OffsetX = reader.ReadInt16();
				array1[num1].m_OffsetY = reader.ReadInt16();
				array1[num1].m_OffsetZ = reader.ReadInt16();
				array1[num1].m_Flags = reader.ReadInt32();
				entry1 = array1[num1];
				if ((num1 == 0) || (entry1.m_Flags != 0))
				{
					if (entry1.m_OffsetX < this.m_Min.m_X)
					{
						this.m_Min.m_X = entry1.m_OffsetX;
 
					}
					if (entry1.m_OffsetY < this.m_Min.m_Y)
					{
						this.m_Min.m_Y = entry1.m_OffsetY;
 
					}
					if (entry1.m_OffsetX > this.m_Max.m_X)
					{
						this.m_Max.m_X = entry1.m_OffsetX;
 
					}
					if (entry1.m_OffsetY > this.m_Max.m_Y)
					{
						this.m_Max.m_Y = entry1.m_OffsetY;
 
					}
 
				}
 
			}
			this.m_Center = new Point2D(-this.m_Min.m_X, -this.m_Min.m_Y);
			this.m_Width = ((this.m_Max.m_X - this.m_Min.m_X) + 1);
			this.m_Height = ((this.m_Max.m_Y - this.m_Min.m_Y) + 1);
			//TRF array2 = new TileList[][this.m_Width];
			array2 = new TileList[this.m_Width][];
			//TRF this.m_Tiles = new Tile[][][this.m_Width];
			this.m_Tiles = new Tile[this.m_Width][][];
			for (num2 = 0; (num2 < this.m_Width); num2 = (num2 + 1))
			{
				array2[num2] = new TileList[this.m_Height];
				//TRF this.m_Tiles[num2] = new Tile[][this.m_Height];
				this.m_Tiles[num2] = new Tile[this.m_Height][];
				for (num3 = 0; (num3 < this.m_Height); num3 = (num3 + 1))
				{
					array2[num2][num3] = new TileList();
 
				}
 
			}
			for (num4 = 0; (num4 < array1.Length); num4 = (num4 + 1))
			{
				if ((num4 == 0) || (array1[num4].m_Flags != 0))
				{
					num5 = (array1[num4].m_OffsetX + this.m_Center.m_X);
					num6 = (array1[num4].m_OffsetY + this.m_Center.m_Y);
					array2[num5][num6].Add(((array1[num4].m_ItemID & 16383) | 16384), ((sbyte) array1[num4].m_OffsetZ));
 
				}
 
			}
			for (num7 = 0; (num7 < this.m_Width); num7 = (num7 + 1))
			{
				for (num8 = 0; (num8 < this.m_Height); num8 = (num8 + 1))
				{
					this.m_Tiles[num7][num8] = array2[num7][num8].ToArray();
 
				}
 
			}
 
		}
		
		public MultiComponentList(GenericReader reader) : base()
		{
				int num1;
			int num2;
			MultiTileEntry[] array1;
			int num3;
			TileList[][] array2;
			int num4;
			int num5;
			int num6;
			int num7;
			int num8;
			int num9;
			int num10;
			int num11;
			MultiTileEntry[] array3;
			num1 = reader.ReadInt();
			num11 = num1;
			if (num11 != 0)
			{
				return; 
			}
			this.m_Min = reader.ReadPoint2D();
			this.m_Max = reader.ReadPoint2D();
			this.m_Center = reader.ReadPoint2D();
			this.m_Width = reader.ReadInt();
			this.m_Height = reader.ReadInt();
			num2 = reader.ReadInt();
			array3 = new MultiTileEntry[num2];
			this.m_List = new MultiTileEntry[num2];
			array1 = array3;
			for (num3 = 0; (num3 < num2); num3 = (num3 + 1))
			{
				array1[num3].m_ItemID = reader.ReadShort();
				array1[num3].m_OffsetX = reader.ReadShort();
				array1[num3].m_OffsetY = reader.ReadShort();
				array1[num3].m_OffsetZ = reader.ReadShort();
				array1[num3].m_Flags = reader.ReadInt();
 
			}
			//TRF array2 = new TileList[][this.m_Width];
			array2 = new TileList[this.m_Width][];
			//TRF this.m_Tiles = new Tile[][][this.m_Width];
			this.m_Tiles = new Tile[this.m_Width][][];
			for (num4 = 0; (num4 < this.m_Width); num4 = (num4 + 1))
			{
				array2[num4] = new TileList[this.m_Height];
				//TRF this.m_Tiles[num4] = new Tile[][this.m_Height];
				this.m_Tiles[num4] = new Tile[this.m_Height][];
				for (num5 = 0; (num5 < this.m_Height); num5 = (num5 + 1))
				{
					array2[num4][num5] = new TileList();
 
				}
 
			}
			for (num6 = 0; (num6 < array1.Length); num6 = (num6 + 1))
			{
				if ((num6 == 0) || (array1[num6].m_Flags != 0))
				{
					num7 = (array1[num6].m_OffsetX + this.m_Center.m_X);
					num8 = (array1[num6].m_OffsetY + this.m_Center.m_Y);
					array2[num7][num8].Add(((array1[num6].m_ItemID & 16383) | 16384), ((sbyte) array1[num6].m_OffsetZ));
 
				}
 
			}
			for (num9 = 0; (num9 < this.m_Width); num9 = (num9 + 1))
			{
				for (num10 = 0; (num10 < this.m_Height); num10 = (num10 + 1))
				{
					this.m_Tiles[num9][num10] = array2[num9][num10].ToArray();
 
				}
 
			}
 
		}
		
		public MultiComponentList(MultiComponentList toCopy) : base()
		{
			int num1;
			int num2;
			int num3;
			int num4;
			this.m_Min = toCopy.m_Min;
			this.m_Max = toCopy.m_Max;
			this.m_Center = toCopy.m_Center;
			this.m_Width = toCopy.m_Width;
			this.m_Height = toCopy.m_Height;
			//TRF this.m_Tiles = new Tile[][][this.m_Width];
			this.m_Tiles = new Tile[this.m_Width][][];
			for (num1 = 0; (num1 < this.m_Width); num1 = (num1 + 1))
			{
				//TRF this.m_Tiles[num1] = new Tile[][this.m_Height];
				this.m_Tiles[num1] = new Tile[this.m_Height][];
				for (num2 = 0; (num2 < this.m_Height); num2 = (num2 + 1))
				{
					this.m_Tiles[num1][num2] = new Tile[toCopy.m_Tiles[num1][num2].Length];
					for (num3 = 0; (num3 < this.m_Tiles[num1][num2].Length); num3 = (num3 + 1))
					{
						this.m_Tiles[num1][num2][num3] = toCopy.m_Tiles[num1][num2][num3];
 
					}
 
				}
 
			}
			this.m_List = new MultiTileEntry[toCopy.m_List.Length];
			for (num4 = 0; (num4 < this.m_List.Length); num4 = (num4 + 1))
			{
				this.m_List[num4] = toCopy.m_List[num4];
 
			}
 
		} 

		public void Add(int itemID, int x, int y, int z)
		{
				int num1;
			int num2;
			Tile[] array1;
			int num3;
			Tile[] array2;
			int num4;
			MultiTileEntry[] array3;
			MultiTileEntry[] array4;
			int num5;
			itemID = (itemID & 16383);
			itemID = (itemID | 16384);
			num1 = (x + this.m_Center.m_X);
			num2 = (y + this.m_Center.m_Y);
			if (((num1 >= 0) && (num1 < this.m_Width)) && ((num2 >= 0) && (num2 < this.m_Height)))
			{
				array1 = this.m_Tiles[num1][num2];
				for (num3 = (array1.Length - 1); (num3 >= 0); num3 = (num3 - 1))
				{
					if ((array1[num3].Z == z) && ((array1[num3].Height > 0) == (TileData.ItemTable[(itemID & 16383)].Height > 0)))
					{
						this.Remove(array1[num3].ID, x, y, z);
 
					}
 
				}
				array1 = this.m_Tiles[num1][num2];
				array2 = new Tile[(array1.Length + 1)];
				for (num4 = 0; (num4 < array1.Length); num4 = (num4 + 1))
				{
					array2[num4] = array1[num4];
 
				}
				array2[array1.Length] = new Tile(((short) itemID), ((sbyte) z));
				this.m_Tiles[num1][num2] = array2;
				array3 = this.m_List;
				array4 = new MultiTileEntry[(array3.Length + 1)];
				for (num5 = 0; (num5 < array3.Length); num5 = (num5 + 1))
				{
					array4[num5] = array3[num5];
 
				}
				array4[array3.Length] = new MultiTileEntry(((short) itemID), ((short) x), ((short) y), ((short) z), 1);
				this.m_List = array4;
				if (x < this.m_Min.m_X)
				{
					this.m_Min.m_X = x;
 
				}
				if (y < this.m_Min.m_Y)
				{
					this.m_Min.m_Y = y;
 
				}
				if (x > this.m_Max.m_X)
				{
					this.m_Max.m_X = x;
 
				}
				if (y > this.m_Max.m_Y)
				{
					this.m_Max.m_Y = y;
 
				}
 
			}
 
		} 

		public void Remove(int itemID, int x, int y, int z)
		{
				int num1;
			int num2;
			Tile[] array1;
			int num3;
			Tile tile1;
			Tile[] array2;
			int num4;
			int num5;
			MultiTileEntry[] array3;
			int num6;
			MultiTileEntry entry1;
			MultiTileEntry[] array4;
			int num7;
			int num8;
			num1 = (x + this.m_Center.m_X);
			num2 = (y + this.m_Center.m_Y);
			if (((num1 < 0) || (num1 >= this.m_Width)) || ((num2 < 0) || (num2 >= this.m_Height)))
			{
				goto L_01F3;
 
			}
			array1 = this.m_Tiles[num1][num2];
			for (num3 = 0; (num3 < array1.Length); num3 = (num3 + 1))
			{
				tile1 = array1[num3];
				if (((tile1.ID & 16383) == (itemID & 16383)) && (tile1.Z == z))
				{
					array2 = new Tile[(array1.Length - 1)];
					for (num4 = 0; (num4 < num3); num4 = (num4 + 1))
					{
						array2[num4] = array1[num4];
 
					}
					for (num5 = (num3 + 1); (num5 < array1.Length); num5 = (num5 + 1))
					{
						array2[(num5 - 1)] = array1[num5];
 
					}
					this.m_Tiles[num1][num2] = array2;
					goto L_0109;
 
				}
 
			}
 
			L_0109:
				array3 = this.m_List;
			for (num6 = 0; (num6 < array3.Length); num6 = (num6 + 1))
			{
				entry1 = array3[num6];
				if ((((entry1.m_ItemID & 16383) == ((short) (itemID & 16383))) && (entry1.m_OffsetX == ((short) x))) && ((entry1.m_OffsetY == ((short) y)) && (entry1.m_OffsetZ == ((short) z))))
				{
					array4 = new MultiTileEntry[(array3.Length - 1)];
					for (num7 = 0; (num7 < num6); num7 = (num7 + 1))
					{
						array4[num7] = array3[num7];
 
					}
					for (num8 = (num6 + 1); (num8 < array3.Length); num8 = (num8 + 1))
					{
						array4[(num8 - 1)] = array3[num8];
 
					}
					this.m_List = array4;
					return; 
				}
 
			}
 
			L_01F3:
				return; 
		}
		
		public void RemoveXYZH(int x, int y, int z, int minHeight)
		{
				int num1;
			int num2;
			Tile[] array1;
			int num3;
			Tile tile1;
			Tile[] array2;
			int num4;
			int num5;
			MultiTileEntry[] array3;
			int num6;
			MultiTileEntry entry1;
			MultiTileEntry[] array4;
			int num7;
			int num8;
			num1 = (x + this.m_Center.m_X);
			num2 = (y + this.m_Center.m_Y);
			if (((num1 < 0) || (num1 >= this.m_Width)) || ((num2 < 0) || (num2 >= this.m_Height)))
			{
				goto L_01EF;
 
			}
			array1 = this.m_Tiles[num1][num2];
			for (num3 = 0; (num3 < array1.Length); num3 = (num3 + 1))
			{
				tile1 = array1[num3];
				if ((tile1.Z == z) && (tile1.Height >= minHeight))
				{
					array2 = new Tile[(array1.Length - 1)];
					for (num4 = 0; (num4 < num3); num4 = (num4 + 1))
					{
						array2[num4] = array1[num4];
 
					}
					for (num5 = (num3 + 1); (num5 < array1.Length); num5 = (num5 + 1))
					{
						array2[(num5 - 1)] = array1[num5];
 
					}
					this.m_Tiles[num1][num2] = array2;
					goto L_00FD;
 
				}
 
			}
 
			L_00FD:
				array3 = this.m_List;
			for (num6 = 0; (num6 < array3.Length); num6 = (num6 + 1))
			{
				entry1 = array3[num6];
				if (((entry1.m_OffsetX == ((short) x)) && (entry1.m_OffsetY == ((short) y))) && ((entry1.m_OffsetZ == ((short) z)) && (TileData.ItemTable[(entry1.m_ItemID & 16383)].Height >= minHeight)))
				{
					array4 = new MultiTileEntry[(array3.Length - 1)];
					for (num7 = 0; (num7 < num6); num7 = (num7 + 1))
					{
						array4[num7] = array3[num7];
 
					}
					for (num8 = (num6 + 1); (num8 < array3.Length); num8 = (num8 + 1))
					{
						array4[(num8 - 1)] = array3[num8];
 
					}
					this.m_List = array4;
					return; 
				}
 
			}
 
			L_01EF:
				return; 
		}
		
		public void Resize(int newWidth, int newHeight)
		{
				int num1;
			int num2;
			Tile[][][] array1;
			int num3;
			Tile[][][] array2;
			int num4;
			int num5;
			int num6;
			int num7;
			int num8;
			Tile[] array3;
			int num9;
			Tile tile1;
			int num10;
			int num11;
			num1 = this.m_Width;
			num2 = this.m_Height;
			array1 = this.m_Tiles;
			num3 = 0;
			//TRF array2 = new Tile[][][newWidth];
			array2 = new Tile[newWidth][][];
			for (num4 = 0; (num4 < newWidth); num4 = (num4 + 1))
			{
				//TRF array2[num4] = new Tile[][newHeight];
				array2[num4] = new Tile[newHeight][];
				for (num5 = 0; (num5 < newHeight); num5 = (num5 + 1))
				{
					if ((num4 < num1) && (num5 < num2))
					{
						array2[num4][num5] = array1[num4][num5];
 
					}
					else
					{
							array2[num4][num5] = new Tile[0];
 
					}
					num3 = (num3 + array2[num4][num5].Length);
 
				}
 
			}
			this.m_Tiles = array2;
			this.m_List = new MultiTileEntry[num3];
			this.m_Width = newWidth;
			this.m_Height = newHeight;
			this.m_Min = Point2D.Zero;
			this.m_Max = Point2D.Zero;
			num6 = 0;
			for (num7 = 0; (num7 < newWidth); num7 = (num7 + 1))
			{
				for (num8 = 0; (num8 < newHeight); num8 = (num8 + 1))
				{
					array3 = array2[num7][num8];
					for (num9 = 0; (num9 < array3.Length); num9 = (num9 + 1))
					{
						tile1 = array3[num9];
						num10 = (num7 - this.m_Center.X);
						num11 = (num8 - this.m_Center.Y);
						if (num10 < this.m_Min.m_X)
						{
							this.m_Min.m_X = num10;
 
						}
						if (num11 < this.m_Min.m_Y)
						{
							this.m_Min.m_Y = num11;
 
						}
						if (num10 > this.m_Max.m_X)
						{
							this.m_Max.m_X = num10;
 
						}
						if (num11 > this.m_Max.m_Y)
						{
							this.m_Max.m_Y = num11;
 
						}
						num6 = (num6 + 1);
						this.m_List[num6] = new MultiTileEntry(((short) tile1.ID), ((short) num10), ((short) num11), ((short) tile1.Z), 1);
 
					}
 
				}
 
			}
 
		}
		
		public void Serialize(GenericWriter writer)
		{
			int num1;
			MultiTileEntry entry1;
			writer.Write(0);
			writer.Write(this.m_Min);
			writer.Write(this.m_Max);
			writer.Write(this.m_Center);
			writer.Write(this.m_Width);
			writer.Write(this.m_Height);
			writer.Write(this.m_List.Length);
			for (num1 = 0; (num1 < this.m_List.Length); num1 = (num1 + 1))
			{
				entry1 = this.m_List[num1];
				writer.Write(entry1.m_ItemID);
				writer.Write(entry1.m_OffsetX);
				writer.Write(entry1.m_OffsetY);
				writer.Write(entry1.m_OffsetZ);
				writer.Write(entry1.m_Flags);
			}
		} 
		
		public Point2D Center { 
			get
			{
				return this.m_Center;
			}
		}

		public int Height 
		{ 
			get
			{
				return this.m_Height;
			}
		}

		public MultiTileEntry[] List 
		{ 
			get
			{
				return this.m_List;
			}
		}

		public Point2D Max 
		{ 
			get
			{
				return this.m_Max;
			}
		}

		public Point2D Min 
		{ 
			get
			{
				return this.m_Min;
			}
		}

		public Tile[][][] Tiles 
		{ 
			get
			{
				return this.m_Tiles;
			}
		}

		public int Width 
		{ 
			get
			{
				return this.m_Width;
			}
		}


		public static readonly MultiComponentList Empty = new MultiComponentList();
		private Point2D m_Center;
		private int m_Height;
		private MultiTileEntry[] m_List;
		private Point2D m_Max;
		private Point2D m_Min;
		private Tile[][][] m_Tiles;
		private int m_Width;
	}
}