using System;
using System.Net;
using System.Net.Sockets;
using System.Collections;
using System.Threading;

namespace Server.Network
{
	public class Listener : IDisposable
	{
		public Listener(int port) : base()
		{
			IPHostEntry entry1;
			ArrayList list1;
			IPAddress[] array1;
			int num1;
			this.m_ThisPort = port;
			this.m_Disposed = false;
			this.m_Accepted = new Queue();
			this.m_OnAccept = new AsyncCallback(this.OnAccept);
			this.m_Listener = this.Bind(IPAddress.Any, port);
			try
			{
				entry1 = Dns.Resolve(Dns.GetHostName());
				list1 = new ArrayList();
				list1.Add(IPAddress.Loopback);
				Console.WriteLine("Address: {0}:{1}", IPAddress.Loopback, port);
				array1 = entry1.AddressList;
				for (num1 = 0; (num1 < array1.Length); num1 = (num1 + 1))
				{
					if (!list1.Contains(array1[num1]))
					{
						list1.Add(array1[num1]);
						Console.WriteLine("Address: {0}:{1}", array1[num1], port);
 
					}
 
				}
 
			}
			catch /*(Exception ignored)*/
			{
  
			}
 
		} 

		private Socket Bind(IPAddress ip, int port)
		{
			// TODO: Validate that this is correct.
			IPEndPoint ep1;
			Socket sock1;
			Socket sock2;
			ep1 = new IPEndPoint(ip, port);
			sock1 = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
			try
			{
				sock1.Bind(ep1);
				sock1.Listen(300);
				sock1.BeginAccept(this.m_OnAccept, sock1);
				sock2 = sock1;
			}
			catch /*(Exception ignored)*/
			{
				try
				{
					sock1.Shutdown(SocketShutdown.Both);
				}
				catch /*(Exception ignored)*/
				{
				}
				try
				{
					sock1.Close();
				}
				catch /*(Exception ignored)*/
				{
				}
				sock2 = null;
			}
			return sock2;
		}

		public void Dispose()
		{
				if (!this.m_Disposed)
		  {
			  this.m_Disposed = true;
			  if (this.m_Listener != null)
			  {
				  try
				  {
					  this.m_Listener.Shutdown(SocketShutdown.Both);
 
				  }
				  catch /*(Exception ignored)*/
				  {
  
				  }
				  try
				  {
					  this.m_Listener.Close();
 
				  }
				  catch /*(Exception ignored)*/
				  {
  
				  }
				  this.m_Listener = null;
 
			  }
 
		  }
 
		} 

		private void OnAccept(IAsyncResult asyncResult)
		{
				Socket socket1;
			object obj1;
			try
			{
				socket1 = this.m_Listener.EndAccept(asyncResult);
				obj1 = this.m_Accepted.SyncRoot;
				Monitor.Enter(this.m_Accepted.SyncRoot);
				try
				{
					this.m_Accepted.Enqueue(socket1);
					goto L_0039;
 
				}
				finally
				{
					Monitor.Exit(obj1);
 
				}
 
			}
			catch /*(Exception ignored)*/
			{
  
			}
			finally
			{
				this.m_Listener.BeginAccept(this.m_OnAccept, this.m_Listener);
 
			}
 
		} 

		public Socket[] Slice()
		{
				object[] array1;
			Socket[] array2;
			Socket[] array3;
			object obj1;
			obj1 = this.m_Accepted.SyncRoot;
			Monitor.Enter(this.m_Accepted.SyncRoot);
			try
			{
				if (this.m_Accepted.Count == 0)
				{
					array3 = Listener.m_EmptySockets;
					goto L_005C;
 
				}
				array1 = this.m_Accepted.ToArray();
				this.m_Accepted.Clear();
				array2 = new Socket[array1.Length];
				Array.Copy(array1, array2, array1.Length);
				array3 = array2;
 
			}
			finally
			{
				Monitor.Exit(obj1);
 
			}
 
			L_005C:
				return array3; 
		} 

		public static int Port { 
			get
			{
				return Listener.m_Port;
			}
			set
			{
				Listener.m_Port = value;
			}
		}

		public int UsedPort { 
			get
			{
				return this.m_ThisPort;
			}
		}
		
		private Queue m_Accepted;
		private bool m_Disposed;
		private static Socket[] m_EmptySockets = new Socket[0];
		private Socket m_Listener;
		private AsyncCallback m_OnAccept;
		private static int m_Port = 2593;
		private int m_ThisPort;
	}
}