using System;
using System.Net;
using System.Net.Sockets;
using System.Collections;
using System.Threading;

namespace Server.Network
{
	public class MessagePump
	{
		public MessagePump(Listener l) : base()
		{
			Listener[] array1;
			array1 = new Listener[1];
			array1[0] = l;
			this.m_Listeners = array1;
			this.m_Queue = new Queue();
			this.m_Throttled = new Queue();
			this.m_Peek = new byte[4];
		} 

		public void AddListener(Listener l)
		{
			Listener[] array1;
			int num1;
			array1 = this.m_Listeners;
			this.m_Listeners = new Listener[(array1.Length + 1)];
			for (num1 = 0; (num1 < array1.Length); num1 = (num1 + 1))
			{
				this.m_Listeners[num1] = array1[num1];
			}
			this.m_Listeners[array1.Length] = l;
		} 

		private void CheckListener()
		{
			int num1;
			Socket[] array1;
			int num2;
			IPAddress address1;
			NetState state1;
			num1 = 0;
			goto L_00AB;
 
			L_0007:
				array1 = this.m_Listeners[num1].Slice();
			num2 = 0;
			goto L_009E;
 
			L_001C:
				try
				{
					address1 = ((IPEndPoint) array1[num2].RemoteEndPoint).Address;
					if (Firewall.IsBlocked(address1))
					{
						Console.WriteLine("Client: {0}: Firewall blocked connection attempt.", address1);
						try
						{
							array1[num2].Shutdown(SocketShutdown.Both);
 
						}
						catch /*(Exception ignored)*/
						{
  
						}
						try
						{
							array1[num2].Close();
							goto L_009A;
 
						}
						catch /*(Exception ignored)*/
						{
							goto L_009A;
 
						}
						goto L_009A;
 
					}
 
				}
				catch /*(Exception ignored)*/
				{
  
				}
			state1 = new NetState(array1[num2], this);
			state1.Start();
			if (state1.Running)
			{
				Console.WriteLine("Client: {0}: Connected. [{1} Online]", state1, NetState.Instances.Count);
 
			}
 
			L_009A:
				num2 = (num2 + 1);
 
			L_009E:
				if (num2 < array1.Length)
				{
					goto L_001C;
 
				}
			num1 = (num1 + 1);
 
			L_00AB:
				if (num1 < this.m_Listeners.Length)
				{
					goto L_0007;
 
				}
 
		}
		
		public bool HandleReceive(NetState ns)
		{
			ByteQueue queue1;
			int num1;
			int num2;
			int num3;
			PacketHandler handler1;
			byte[] array1;
			int num4;
			ThrottlePacketCallback callback1;
			PacketProfile profile1;
			DateTime time1;
			PacketReader reader1;
			bool flag1;
			NetState state1;
			state1 = ns;
			Monitor.Enter(ns);
			try
			{
				queue1 = ns.Buffer;
				if (queue1 == null)
				{
					flag1 = true;
					goto L_026B;
 
				}
				num1 = queue1.Length;
				if (ns.Seeded)
				{
					goto L_0250;
 
				}
				if (num1 >= 4)
				{
					queue1.Dequeue(this.m_Peek, 0, 4);
					num2 = ((((this.m_Peek[0] << 24) | (this.m_Peek[1] << 16)) | (this.m_Peek[2] << 8)) | this.m_Peek[3]);
					if (num2 == 0)
					{
						Console.WriteLine("Login: {0}: Invalid client detected, disconnecting", ns);
						ns.Dispose();
						flag1 = false;
						goto L_026B;
 
					}
					ns.m_Seed = num2;
					ns.Seeded = true;
 
				}
				flag1 = true;
				goto L_026B;
 
			L_009D:
				queue1.Peek(this.m_Peek, 0, 1);
				num3 = this.m_Peek[0];
				if (((!ns.SentFirstPacket && (num3 != 241)) && ((num3 != 207) && (num3 != 128))) && ((num3 != 145) && (num3 != 164)))
				{
					Console.WriteLine("Client: {0}: Encrypted client detected, disconnecting", ns);
					ns.Dispose();
					goto L_025F;
 
				}
				handler1 = PacketHandlers.GetHandler(num3);
				if (handler1 == null)
				{
					array1 = queue1.Dequeue(num1);
					new PacketReader(array1, 0).Trace(ns);
					goto L_025F;
 
				}
				num4 = handler1.Length;
				if (num4 <= 0)
				{
					if (num1 < 3)
					{
						goto L_025F;
 
					}
					queue1.Peek(this.m_Peek, 0, 3);
					num4 = ((this.m_Peek[1] << 8) | this.m_Peek[2]);
					if (num4 < 3)
					{
						ns.Dispose();
						goto L_025F;
 
					}
 
				}
				if (num1 < num4)
				{
					goto L_025F;
 
				}
				if (handler1.Ingame && (ns.Mobile == null))
				{
					Console.WriteLine("Client: {0}: Sent ingame packet (0x{1:X2}) before having been attached to a mobile", ns, num3);
					ns.Dispose();
					goto L_025F;
 
				}
				if (handler1.Ingame && ns.Mobile.Deleted)
				{
					ns.Dispose();
					goto L_025F;
 
				}
				callback1 = handler1.ThrottleCallback;
				if ((callback1 != null) && !callback1.Invoke(ns))
				{
					this.m_Throttled.Enqueue(ns);
					flag1 = false;
					goto L_026B;
 
				}
				profile1 = PacketProfile.GetIncomingProfile(num3);
				time1 = ((profile1 == null) ? DateTime.MinValue : DateTime.Now);
				reader1 = new PacketReader(queue1.Dequeue(num4), ((handler1.Length == 0) == 0));
				handler1.OnReceive.Invoke(ns, reader1);
				num1 = queue1.Length;
				if (profile1 != null)
				{
					profile1.Record(num4, DateTime.op_Subtraction(DateTime.Now, time1));
 
				}
 
			L_0250:
				if ((num1 > 0) && ns.Running)
				{
					goto L_009D;
 
				}
 
			L_025F:
				goto L_0269;
 
			}
			finally
			{
				Monitor.Exit(state1);
 
			}
 
			L_0269:
				return true; 
			L_026B:
				return flag1; 
		}
		
		public void OnReceive(NetState ns)
		{
				object obj1;
			obj1 = this.m_Queue.SyncRoot;
			Monitor.Enter(this.m_Queue.SyncRoot);
			try
			{
				this.m_Queue.Enqueue(ns);
 
			}
			finally
			{
				Monitor.Exit(obj1);
 
			}
 
		} 

		public void Slice()
		{
				NetState state1;
			object obj1;
			this.CheckListener();
			obj1 = this.m_Queue.SyncRoot;
			Monitor.Enter(this.m_Queue.SyncRoot);
			try
			{
				while ((this.m_Queue.Count > 0))
				{
					state1 = ((NetState) this.m_Queue.Dequeue());
					if ((state1.Running && this.HandleReceive(state1)) && state1.Running)
					{
						state1.Continue();
					}
				}
				while ((this.m_Throttled.Count > 0))
				{
					this.m_Queue.Enqueue(this.m_Throttled.Dequeue());
				}
			}
			finally
			{
				Monitor.Exit(obj1);
			}
		} 

		public Listener[] Listeners 
		{ 
			get
			{
				return this.m_Listeners;
			}
			set
			{
				this.m_Listeners = value;
			}
		}
		
		private Listener[] m_Listeners;
		private byte[] m_Peek;
		private Queue m_Queue;
		private Queue m_Throttled;
	}
}