using System;
using System.Net;

namespace Server.Network
{
	public sealed class ServerInfo
	{
		public ServerInfo(string name, int fullPercent, TimeZone tz, IPEndPoint address) : base()
		{
			TimeSpan span1;
			this.m_Name = name;
			this.m_FullPercent = fullPercent;
			span1 = tz.GetUtcOffset(DateTime.Now);
			this.m_TimeZone = span1.Hours;
			this.m_Address = address;
		} 
		
		public IPEndPoint Address { 
			get
			{
				return this.m_Address;
			}
			set
			{
				this.m_Address = value;
			}
		}

		public int FullPercent { 
			get
			{
				return this.m_FullPercent;
			}
			set
			{
				this.m_FullPercent = value;
			}
		}

		public string Name 
		{ 
			get
			{
				return this.m_Name;
			}
			set
			{
				this.m_Name = value;
			}
		}

		public int TimeZone 
		{ 
			get
			{
				return this.m_TimeZone;
			}
			set
			{
				this.m_TimeZone = value;
			}
		}

		private IPEndPoint m_Address;
		private int m_FullPercent;
		private string m_Name;
		private int m_TimeZone;
	}
}