using System;

namespace Server
{
	public struct Point2D : IPoint2D
	{
		public Point2D(int x, int y)
		{
				this.m_X = x;
			this.m_Y = y;
 
		} 

		public Point2D(IPoint2D p) : this(p.X, p.Y)
		{
		} 

		public override bool Equals(object o)
		{
				IPoint2D pointd1;
			if ((o == null) || ((o as IPoint2D) == null))
			{
				return false; 
			}
			pointd1 = ((IPoint2D) o);
			if (this.m_X == pointd1.X)
			{
				return (this.m_Y == pointd1.Y); 
			}
			return false; 
		} 

		public override int GetHashCode()
		{
				return (this.m_X ^ this.m_Y); 
		} 

		public static bool operator ==(Point2D l, IPoint2D r)
		{
				if (l.m_X == r.X)
		  {
			  return (l.m_Y == r.Y); 
		  }
			return false; 
		} 

		public static bool operator ==(Point2D l, Point2D r)
		{
				if (l.m_X == r.m_X)
		  {
			  return (l.m_Y == r.m_Y); 
		  }
			return false; 
		} 

		public static bool operator >(Point2D l, IPoint2D r)
		{
				if (l.m_X > r.X)
		  {
			  return (l.m_Y > r.Y); 
		  }
			return false; 
		} 

		public static bool operator >(Point2D l, Point2D r)
		{
				if (l.m_X > r.m_X)
		  {
			  return (l.m_Y > r.m_Y); 
		  }
			return false; 
		} 

		public static bool operator >(Point2D l, Point3D r)
		{
				if (l.m_X > r.m_X)
		  {
			  return (l.m_Y > r.m_Y); 
		  }
			return false; 
		} 

		public static bool operator >=(Point2D l, IPoint2D r)
		{
				if (l.m_X >= r.X)
		  {
			  return !(l.m_Y < r.Y); 
		  }
			return false; 
		} 

		public static bool operator >=(Point2D l, Point2D r)
		{
				if (l.m_X >= r.m_X)
		  {
			  return !(l.m_Y < r.m_Y); 
		  }
			return false; 
		} 

		public static bool operator >=(Point2D l, Point3D r)
		{
				if (l.m_X >= r.m_X)
		  {
			  return !(l.m_Y < r.m_Y); 
		  }
			return false; 
		} 

		public static bool operator !=(Point2D l, IPoint2D r)
		{
				if (l.m_X == r.X)
		  {
			  return (l.m_Y != r.Y); 
		  }
			return true; 
		} 

		public static bool operator !=(Point2D l, Point2D r)
		{
				if (l.m_X == r.m_X)
		  {
			  return (l.m_Y != r.m_Y); 
		  }
			return true; 
		} 

		public static bool operator <(Point2D l, IPoint2D r)
		{
				if (l.m_X < r.X)
		  {
			  return (l.m_Y < r.Y); 
		  }
			return false; 
		} 

		public static bool operator <(Point2D l, Point2D r)
		{
				if (l.m_X < r.m_X)
		  {
			  return (l.m_Y < r.m_Y); 
		  }
			return false; 
		} 

		public static bool operator <(Point2D l, Point3D r)
		{
				if (l.m_X < r.m_X)
		  {
			  return (l.m_Y < r.m_Y); 
		  }
			return false; 
		} 

		public static bool operator <=(Point2D l, IPoint2D r)
		{
				if (l.m_X <= r.X)
		  {
			  return !(l.m_Y > r.Y); 
		  }
			return false; 
		} 

		public static bool operator <=(Point2D l, Point2D r)
		{
				if (l.m_X <= r.m_X)
		  {
			  return !(l.m_Y > r.m_Y); 
		  }
			return false; 
		} 

		public static bool operator <=(Point2D l, Point3D r)
		{
				if (l.m_X <= r.m_X)
		  {
			  return !(l.m_Y > r.m_Y); 
		  }
			return false; 
		} 

		public static Point2D Parse(string value)
		{
				int num1;
			int num2;
			string text1;
			string text2;
			num1 = value.IndexOf(40);
			num2 = value.IndexOf(44, (num1 + 1));
			text1 = value.Substring((num1 + 1), (num2 - (num1 + 1))).Trim();
			num1 = num2;
			num2 = value.IndexOf(41, (num1 + 1));
			text2 = value.Substring((num1 + 1), (num2 - (num1 + 1))).Trim();
			return new Point2D(Convert.ToInt32(text1), Convert.ToInt32(text2)); 
		} 

		public override string ToString()
		{
				return string.Format("({0}, {1})", this.m_X, this.m_Y); 
		} 

		public int X { 
			get
			{
				return this.m_X;
			}
			set
			{
				this.m_X = value;
			}
		}

		public int Y { 
			get
			{
				return this.m_Y;
			}
			set
			{
				this.m_Y = value;
			}
		}

		internal int m_X;
		internal int m_Y;
		public static readonly Point2D Zero = new Point2D(0,0);
	}

	public struct Point3D : IPoint3D
	{
		public Point3D(int x, int y, int z)
		{
			this.m_X = x;
			this.m_Y = y;
			this.m_Z = z;
		}

		public Point3D(IPoint2D p, int z) : this(p.X, p.Y, z)
		{
		}

		public Point3D(IPoint3D p) : this(p.X, p.Y, p.Z)
		{
		}

		public override bool Equals(object o)
		{
			IPoint3D pointd1;
			if ((o == null) || ((o as IPoint3D) == null))
			{
				return false; 
			}
			pointd1 = ((IPoint3D) o);
			if ((this.m_X == pointd1.X) && (this.m_Y == pointd1.Y))
			{
				return (this.m_Z == pointd1.Z); 
			}
			return false; 
		}
		
		public override int GetHashCode()
		{
			return ((this.m_X ^ this.m_Y) ^ this.m_Z); 
		} 

		public static bool operator ==(Point3D l, IPoint3D r)
		{
			if ((l.m_X == r.X) && (l.m_Y == r.Y))
			{
				return (l.m_Z == r.Z); 
			}
			return false; 
		} 

		public static bool operator ==(Point3D l, Point3D r)
		{
			if ((l.m_X == r.m_X) && (l.m_Y == r.m_Y))
			{
				return (l.m_Z == r.m_Z); 
			}
			return false; 
		} 

		public static bool operator !=(Point3D l, IPoint3D r)
		{
			if ((l.m_X == r.X) && (l.m_Y == r.Y))
			{
				return (l.m_Z != r.Z); 
			}
			return true; 
		} 

		public static bool operator !=(Point3D l, Point3D r)
		{
			if ((l.m_X == r.m_X) && (l.m_Y == r.m_Y))
			{
				return (l.m_Z != r.m_Z); 
			}
			return true; 
		} 

		public static Point3D Parse(string value)
		{
			int num1;
			int num2;
			string text1;
			string text2;
			string text3;
			num1 = value.IndexOf(40);
			num2 = value.IndexOf(44, (num1 + 1));
			text1 = value.Substring((num1 + 1), (num2 - (num1 + 1))).Trim();
			num1 = num2;
			num2 = value.IndexOf(44, (num1 + 1));
			text2 = value.Substring((num1 + 1), (num2 - (num1 + 1))).Trim();
			num1 = num2;
			num2 = value.IndexOf(41, (num1 + 1));
			text3 = value.Substring((num1 + 1), (num2 - (num1 + 1))).Trim();
			return new Point3D(Convert.ToInt32(text1), Convert.ToInt32(text2), Convert.ToInt32(text3)); 
		} 

		public override string ToString()
		{
			return string.Format("({0}, {1}, {2})", this.m_X, this.m_Y, this.m_Z); 
		}

		public int X 
		{ 
			get
			{
				return this.m_X;
			}
			set
			{
				this.m_X = value;
			}
		}

		public int Y 
		{ 
			get
			{
				return this.m_Y;
			}
			set
			{
				this.m_Y = value;
			}
		}

		public int Z 
		{ 
			get
			{
				return this.m_Z;
			}
			set
			{
				this.m_Z = value;
			}
		}

		internal int m_X;
		internal int m_Y;
		internal int m_Z;
		public static readonly Point3D Zero = new Point3D(0,0,0);
	}

	public class Point3DList
	{
		public Point3DList() : base()
		{
			this.m_List = new Point3D[8];
			this.m_Count = 0;
		} 

		public void Add(int x, int y, int z)
		{
				Point3D[] array1;
			int num1;
			if ((this.m_Count + 1) > this.m_List.Length)
			{
				array1 = this.m_List;
				this.m_List = new Point3D[(array1.Length * 2)];
				for (num1 = 0; (num1 < array1.Length); num1 = (num1 + 1))
				{
					this.m_List[num1] = array1[num1];
 
				}
 
			}
			this.m_List[this.m_Count].m_X = x;
			this.m_List[this.m_Count].m_Y = y;
			this.m_List[this.m_Count].m_Z = z;
			this.m_Count = (this.m_Count + 1);
 
		} 

		
		public void Add(Point3D p)
		{
				Point3D[] array1;
			int num1;
			if ((this.m_Count + 1) > this.m_List.Length)
			{
				array1 = this.m_List;
				this.m_List = new Point3D[(array1.Length * 2)];
				for (num1 = 0; (num1 < array1.Length); num1 = (num1 + 1))
				{
					this.m_List[num1] = array1[num1];
 
				}
 
			}
			this.m_List[this.m_Count].m_X = p.m_X;
			this.m_List[this.m_Count].m_Y = p.m_Y;
			this.m_List[this.m_Count].m_Z = p.m_Z;
			this.m_Count = (this.m_Count + 1);
 
		} 

		public void Clear()
		{
				this.m_Count = 0;
 
		} 

		public Point3D[] ToArray()
		{
				Point3D[] array1;
			int num1;
			if (this.m_Count == 0)
			{
				return Point3DList.m_EmptyList; 
			}
			array1 = new Point3D[this.m_Count];
			for (num1 = 0; (num1 < this.m_Count); num1 = (num1 + 1))
			{
				array1[num1] = this.m_List[num1];
 
			}
			this.m_Count = 0;
			return array1; 
		} 

		public int Count { 
			get
			{
				return this.m_Count;
			}
		}

		public Point3D this[int index] { 
			get
			{
				return this.m_List[index];
			}
		}
		public Point3D Last { 
			get
			{
				return this.m_List[(this.m_Count - 1)];
			}
		}
		
		private int m_Count;
		private static Point3D[] m_EmptyList = new Point3D[0];
		private Point3D[] m_List;
	}

	public struct Rectangle2D
	{
		public Rectangle2D(int x, int y, int width, int height)
		{
			this.m_Start = new Point2D(x, y);
			this.m_End = new Point2D((x + width), (y + height));
		} 

		public Rectangle2D(IPoint2D start, IPoint2D end)
		{
			this.m_Start = new Point2D(start);
			this.m_End = new Point2D(end);
		}

		public bool Contains(IPoint2D p)
		{
				if (Point2D.op_LessThanOrEqual(this.m_Start, p))
		  {
			  return Point2D.op_GreaterThan(this.m_End, p); 
		  }
			return false; 
		} 

		public bool Contains(Point2D p)
		{
				if (((this.m_Start.m_X <= p.m_X) && (this.m_Start.m_Y <= p.m_Y)) && (this.m_End.m_X > p.m_X))
		  {
			  return (this.m_End.m_Y > p.m_Y); 
		  }
			return false; 
		} 

		public bool Contains(Point3D p)
		{
				if (((this.m_Start.m_X <= p.m_X) && (this.m_Start.m_Y <= p.m_Y)) && (this.m_End.m_X > p.m_X))
		  {
			  return (this.m_End.m_Y > p.m_Y); 
		  }
			return false; 
		} 

		public void MakeHold(Rectangle2D r)
		{
				if (r.m_Start.m_X < this.m_Start.m_X)
		  {
			  this.m_Start.m_X = r.m_Start.m_X;
 
		  }
			if (r.m_Start.m_Y < this.m_Start.m_Y)
			{
				this.m_Start.m_Y = r.m_Start.m_Y;
 
			}
			if (r.m_End.m_X > this.m_End.m_X)
			{
				this.m_End.m_X = r.m_End.m_X;
 
			}
			if (r.m_End.m_Y > this.m_End.m_Y)
			{
				this.m_End.m_Y = r.m_End.m_Y;
 
			}
 
		} 

		public static Rectangle2D Parse(string value)
		{
				int num1;
			int num2;
			string text1;
			string text2;
			string text3;
			string text4;
			num1 = value.IndexOf(40);
			num2 = value.IndexOf(44, (num1 + 1));
			text1 = value.Substring((num1 + 1), (num2 - (num1 + 1))).Trim();
			num1 = num2;
			num2 = value.IndexOf(44, (num1 + 1));
			text2 = value.Substring((num1 + 1), (num2 - (num1 + 1))).Trim();
			num1 = num2;
			num2 = value.IndexOf(44, (num1 + 1));
			text3 = value.Substring((num1 + 1), (num2 - (num1 + 1))).Trim();
			num1 = num2;
			num2 = value.IndexOf(41, (num1 + 1));
			text4 = value.Substring((num1 + 1), (num2 - (num1 + 1))).Trim();
			return new Rectangle2D(Convert.ToInt32(text1), Convert.ToInt32(text2), Convert.ToInt32(text3), Convert.ToInt32(text4)); 
		} 

		public void Set(int x, int y, int width, int height)
		{
			this.m_Start = new Point2D(x, y);
			this.m_End = new Point2D((x + width), (y + height));
		} 

		public override string ToString()
		{
			object[] array1;
			array1 = new object[4];
			array1[0] = this.X;
			array1[1] = this.Y;
			array1[2] = this.Width;
			array1[3] = this.Height;
			return string.Format("({0}, {1})+({2}, {3})", array1); 
		} 

		public Point2D End { 
			get
			{
				return this.m_End;
			}
			set
			{
				this.m_End = value;
			}
		}

		public int Height 
		{ 
			get
			{
				return (this.m_End.m_Y - this.m_Start.m_Y);
			}
			set
			{
				this.m_End.m_Y = (this.m_Start.m_Y + value);
			}
		}

		public Point2D Start 
		{ 
			get
			{
				return this.m_Start;
			}
			set
			{
				this.m_Start = value;
			}
		}

		public int Width 
		{ 
			get
			{
				return (this.m_End.m_X - this.m_Start.m_X);
			}
			set
			{
				this.m_End.m_X = (this.m_Start.m_X + value);
			}
		}

		public int X 
		{ 
			get
			{
				return this.m_Start.m_X;
			}
			set
			{
				this.m_Start.m_X = value;
			}
		}

		public int Y 
		{ 
			get
			{
				return this.m_Start.m_Y;
			}
			set
			{
				this.m_Start.m_Y = value;
			}
		}


		private Point2D m_End;
		private Point2D m_Start;
	}

	public struct Rectangle3D
	{
		public Rectangle3D(int x, int y, int z, int width, int height, int depth)
		{
			this.m_Start = new Point3D(x, y, z);
			this.m_End = new Point3D((x + width), (y + height), (z + depth));
		} 

		public Rectangle3D(Point3D start, Point3D end)
		{
			this.m_Start = start;
			this.m_End = end;
		} 

		public bool Contains(IPoint3D p)
		{
				if (((p.X >= this.m_Start.X) && (p.X < this.m_End.X)) && (((p.Y >= this.m_Start.Y) && (p.Y < this.m_End.Y)) && (p.Z >= this.m_Start.Z)))
		  {
			  return (p.Z < this.m_End.Z); 
		  }
			return false; 
		} 

		public int Depth { 
			get
			{
				return (this.m_End.Z - this.m_Start.Z); 
			}
		}

		public Point3D End { 
			get
			{
				return this.m_End;
			}
			set
			{
				this.m_End = value;
			}
		}

		public int Height 
		{ 
			get
			{
				return (this.m_End.Y - this.m_Start.Y);
			}
		}

		public Point3D Start 
		{ 
			get
			{
				return this.m_Start;
			}
			set
			{
				this.m_Start = value;
			}
		}

		public int Width 
		{ 
			get
			{
				return (this.m_End.X - this.m_Start.X); 
			}
		}

		private Point3D m_End;
		private Point3D m_Start;
	}

}