using System;

namespace Server
{
	public class QuestArrow
	{
		public QuestArrow(Mobile m) : base()
		{
			this.m_Running = true;
			this.m_Mobile = m;
		} 

		public QuestArrow(Mobile m, int x, int y) : this(m)
		{
			this.Update(x,y);
		}

		public virtual void OnClick(bool rightClick)
		{
		}

		public virtual void OnStop()
		{
		}

		public void Stop()
		{
				if (!this.m_Running)
		  {
			  return; 
		  }
			this.m_Mobile.ClearQuestArrow();
			this.m_Mobile.Send(new CancelArrow());
			this.m_Running = false;
			this.OnStop();
 
		} 

		public void Update(int x, int y)
		{
				if (this.m_Running)
		  {
			  this.m_Mobile.Send(new SetArrow(x, y));
 
		  }
 
		} 

		public Mobile Mobile { 
			get
			{
				return this.m_Mobile;
			}
		}

		public bool Running { 
			get
			{
				return this.m_Running;
			}
		}
		
		private Mobile m_Mobile;
		private bool m_Running;
	}
}