using System;

namespace Server
{
	public struct Serial : IComparable
	{
		private Serial(int serial)
		{
			this.m_Serial = serial;
		}

		public int CompareTo(object o)
		{
				int num1;
			Serial serial1;
			if (o == null)
			{
				return 1; 
			}
			if ((o as Serial) == 0)
			{
				throw new ArgumentException();
 
			}
			serial1 = ((Serial) o);
			num1 = serial1.m_Serial;
			if (this.m_Serial > num1)
			{
				return 1; 
			}
			if (this.m_Serial < num1)
			{
				return -1; 
			}
			return 0; 
		} 

		public override bool Equals(object o)
		{
				Serial serial1;
			if ((o == null) || ((o as Serial) == 0))
			{
				return false; 
			}
			serial1 = ((Serial) o);
			return (serial1.m_Serial == this.m_Serial); 
		} 

		public override int GetHashCode()
		{
				return this.m_Serial; 
		} 

		public static bool operator ==(Serial l, Serial r)
		{
				return (l.m_Serial == r.m_Serial); 
		} 

		public static bool operator >(Serial l, Serial r)
		{
				return (l.m_Serial > r.m_Serial); 
		} 

		public static bool operator >=(Serial l, Serial r)
		{
				return !(l.m_Serial < r.m_Serial); 
		} 

		public static implicit operator Serial(int a)
		{
				return new Serial(a); 
		} 

		public static implicit operator int(Serial a)
		{
				return a.m_Serial; 
		} 

		public static bool operator !=(Serial l, Serial r)
		{
				return (l.m_Serial != r.m_Serial); 
		} 

		public static bool operator <(Serial l, Serial r)
		{
				return (l.m_Serial < r.m_Serial); 
		} 

		public static bool operator <=(Serial l, Serial r)
		{
				return !(l.m_Serial > r.m_Serial); 
		} 

		public override string ToString()
		{
				return string.Format("0x{0:X8}", this.m_Serial); 
		} 

		public bool IsItem { 
			get
			{
				if (this.m_Serial >= 1073741824)
				{
					return !(this.m_Serial > 2147483647); 
				}
				return false;
			}
		}

		public bool IsMobile 
		{ 
			get
			{
				if (this.m_Serial > 0)
				{
					return (this.m_Serial < 1073741824); 
				}
				return false;
			}
		}

		public bool IsValid 
		{ 
			get
			{
				return (this.m_Serial > 0); 
			}
		}

		public static Serial NewItem 
		{ 
			get
			{
				L_0000:
					Serial.m_LastItem = Serial.op_Implicit((Serial.op_Implicit(Serial.m_LastItem) + 1));
				if (World.FindItem(Serial.op_Implicit((Serial.op_Implicit(Serial.m_LastItem) + 1))) != null)
				{
					goto L_0000;
 
				}
				return Serial.m_LastItem; 
			}
		}

		public static Serial NewMobile 
		{ 
			get
			{
				L_0000:
					Serial.m_LastMobile = Serial.op_Implicit((Serial.op_Implicit(Serial.m_LastMobile) + 1));
				if (World.FindMobile(Serial.op_Implicit((Serial.op_Implicit(Serial.m_LastMobile) + 1))) != null)
				{
					goto L_0000;
 
				}
				return Serial.m_LastMobile; 
			}
		}

		public int Value 
		{ 
			get
			{
				return this.m_Serial; 
			}
		}
		
		private static Serial m_LastItem = Serial.op_Implicit(1073741824);
		private static Serial m_LastMobile = Serial.Zero;
		private int m_Serial;
		public static readonly Serial MinusOne = new Serial(-1);
		public static readonly Serial Zero = new Serial(0);
	}
}