using System;

namespace Server
{
	public class Skill
	{
		public Skill(Skills owner, SkillInfo info, GenericReader reader) : base()
		{
			int num1;
			int num2;
			this.m_Owner = owner;
			this.m_Info = info;
			num1 = reader.ReadByte();
			num2 = num1;
			if (num2 != 0)
			{
				if (num2 == 255)
				{
					goto L_0050;
 
				}
				goto L_006A;
 
			}
			this.m_Base = reader.ReadUShort();
			this.m_Cap = reader.ReadUShort();
			this.m_Lock = reader.ReadByte();
			return; 
			L_0050:
				this.m_Base = 0;
			this.m_Cap = 1000;
			this.m_Lock = 0;
			return; 
			L_006A:
				if ((num1 & 192) == 0)
				{
					if ((num1 & 1) != 0)
					{
						this.m_Base = reader.ReadUShort();
 
					}
					if ((num1 & 2) != 0)
					{
						this.m_Cap = reader.ReadUShort();
 
					}
					else
					{
						this.m_Cap = 1000;
 
					}
					if ((num1 & 4) != 0)
					{
						this.m_Lock = reader.ReadByte();
 
					}
				}
		} 

		public Skill(Skills owner, SkillInfo info, int baseValue, int cap, SkillLock skillLock) : base()
		{
			this.m_Owner = owner;
			this.m_Info = info;
			this.m_Base = ((ushort) baseValue);
			this.m_Cap = ((ushort) cap);
			this.m_Lock = skillLock;
		} 

		public void Serialize(GenericWriter writer)
		{
			int num1;
			if (((this.m_Base == 0) && (this.m_Cap == 1000)) && (this.m_Lock == 0))
			{
				writer.Write(255);
				return; 
			}
			num1 = 0;
			if (this.m_Base != 0)
			{
				num1 = (num1 | 1);
			}
			if (this.m_Cap != 1000)
			{
				num1 = (num1 | 2);
			}
			if (this.m_Lock != 0)
			{
				num1 = (num1 | 4);
			}
			writer.Write(((byte) num1));
			if (this.m_Base != 0)
			{
				writer.Write(((short) this.m_Base));
			}
			if (this.m_Cap != 1000)
			{
				writer.Write(((short) this.m_Cap));
			}
			if (this.m_Lock != 0)
			{
				writer.Write(this.m_Lock);
			}
		} 

		public void SetLockNoRelay(SkillLock skillLock)
		{
			this.m_Lock = skillLock;
		}
		
		public override string ToString()
		{
			return string.Format("[{0}: {1}]", this.Name, this.Base); 
		} 

		public void Update()
		{
			this.m_Owner.OnSkillChange(this);
		} 
		
		public double Base 
		{ 
			get
			{
				return (((double) this.m_Base) / 10); 
			}
			set
			{
				this.BaseFixedPoint = ((int) (value * 10));
			}
		}

		public int BaseFixedPoint 
		{ 
			get
			{
				return this.m_Base;
			}
			set
			{
				ushort num1;
				int num2;
				Mobile mobile1;
				if (value < 0)
				{
					value = 0;
 
				}
				else
				{
					if (value >= 65536)
					{
						value = 65535;
 
					}
 
				}
				num1 = ((ushort) value);
				num2 = this.m_Base;
				if (this.m_Base != num1)
				{
					this.m_Owner.Total = ((this.m_Owner.Total - this.m_Base) + num1);
					this.m_Base = num1;
					this.m_Owner.OnSkillChange(this);
					mobile1 = this.m_Owner.Owner;
					if (mobile1 != null)
					{
						mobile1.OnSkillChange(this.SkillName, (((double) num2) / 10));
 
					}
				}
			}
		}

		public double Cap 
		{ 
			get
			{
				return (((double) this.m_Cap) / 10); 
			}
			set
			{
				this.CapFixedPoint = ((int) (value * 10));
			}
		}

		public int CapFixedPoint 
		{ 
			get
			{
				return this.m_Cap;
			}
			set
			{
				ushort num1;
				if (value < 0)
				{
					value = 0;
 
				}
				else
				{
					if (value >= 65536)
					{
						value = 65535;
 
					}
 
				}
				num1 = ((ushort) value);
				if (this.m_Cap != num1)
				{
					this.m_Cap = num1;
					this.m_Owner.OnSkillChange(this);
 
				}
			}
		}

		public int Fixed 
		{ 
			get
			{
				return ((int)(this.Value * 10));
			}
		}

		public SkillInfo Info 
		{ 
			get
			{
				return this.m_Info;
			}
		}

		public SkillLock Lock 
		{ 
			get
			{
				return this.m_Lock;
			}
		}

		public string Name 
		{ 
			get
			{
				return this.m_Info.Name;
			}
		}

		public Skills Owner 
		{ 
			get
			{
				return this.m_Owner;
			}
		}

		public int SkillID 
		{ 
			get
			{
				return this.m_Info.SkillID;
			}
		}

		public SkillName SkillName 
		{ 
			get
			{
				return this.m_Info.SkillID;
			}
		}

		public static bool UseStatMods 
		{ 
			get
			{
				return Skill.m_UseStatMods;
			}
			set
			{
				Skill.m_UseStatMods = value;
			}
		}

		public double Value 
		{ 
			get
			{
				double num1;
				double num2;
				double num3;
				double num4;
				double num5;
				ArrayList list1;
				double num6;
				double num7;
				int num8;
				SkillMod mod1;
				num1 = this.Base;
				num2 = (100 - num1);
				if (num2 < 0)
				{
					num2 = 0;
 
				}
				num2 = (num2 / 100);
				num3 = (((((double) (Skill.m_UseStatMods ? this.m_Owner.Owner.Str : this.m_Owner.Owner.RawStr)) * this.m_Info.StrScale) + (((double) (Skill.m_UseStatMods ? this.m_Owner.Owner.Dex : this.m_Owner.Owner.RawDex)) * this.m_Info.DexScale)) + (((double) (Skill.m_UseStatMods ? this.m_Owner.Owner.Int : this.m_Owner.Owner.RawInt)) * this.m_Info.IntScale));
				num4 = (this.m_Info.StatTotal * num2);
				num3 = (num3 * num2);
				if (num3 > num4)
				{
					num3 = num4;
 
				}
				num5 = (num1 + num3);
				this.m_Owner.Owner.ValidateSkillMods();
				list1 = this.m_Owner.Owner.SkillMods;
				num6 = 0;
				num7 = 0;
				num8 = 0;
				goto L_01AB;
 
				L_0134:
					mod1 = ((SkillMod) list1[num8]);
				if (mod1.Skill == this.m_Info.SkillID)
				{
					if (mod1.Relative)
					{
						if (mod1.ObeyCap)
						{
							num6 = (num6 + mod1.Value);
							goto L_01A5;
 
						}
						num7 = (num7 + mod1.Value);
 
					}
					else
					{
						num6 = 0;
						num7 = 0;
						num5 = mod1.Value;
 
					}
 
				}
 
				L_01A5:
					num8 = (num8 + 1);
 
				L_01AB:
					if (num8 < list1.Count)
					{
						goto L_0134;
					}
				num5 = (num5 + num7);
				if (num5 < this.Cap)
				{
					num5 = (num5 + num6);
					if (num5 > this.Cap)
					{
						num5 = this.Cap;
					}
				}
				return num5; 
			}
		}

		private ushort m_Base;
		private ushort m_Cap;
		private SkillInfo m_Info;
		private SkillLock m_Lock;
		private Skills m_Owner;
		private static bool m_UseStatMods;
	}

	public class Skills
	{
		public Skills(Mobile owner) : base()
		{
			SkillInfo[] array1;
			this.m_Owner = owner;
			this.m_Cap = 7000;
			array1 = SkillInfo.Table;
			this.m_Skills = new Skill[array1.Length];
		} 

		public Skills(Mobile owner, GenericReader reader) : base()
		{
			int num1;
			SkillInfo[] array1;
			int num2;
			int num3;
			Skill skill1;
			int num4;
			this.m_Owner = owner;
			num1 = reader.ReadInt();
			num4 = num1;
			switch (num4)
			{
				case 0:
				{
					reader.ReadInt();
					goto L_003B;
 
				}
				case 1:
				{
					goto L_003B;
 
				}
				case 2:
				{
					goto L_002F;
 
				}
				case 3:
				{
					goto L_002F;
 
				}
 
			}
			return; 
			L_002F:
				this.m_Cap = reader.ReadInt();
 
			L_003B:
				if (num1 < 2)
				{
					this.m_Cap = 7000;
				}
			if (num1 < 3)
			{
				reader.ReadInt();
			}
			array1 = SkillInfo.Table;
			this.m_Skills = new Skill[array1.Length];
			num2 = reader.ReadInt();
			for (num3 = 0; (num3 < num2); num3 = (num3 + 1))
			{
				if (num3 < array1.Length)
				{
					skill1 = new Skill(this, array1[num3], reader);
					if (((skill1.BaseFixedPoint == 0) && (skill1.CapFixedPoint == 1000)) && (skill1.Lock == 0))
					{
						goto L_00CF;
					}
					this.m_Skills[num3] = skill1;
					this.m_Total = (this.m_Total + skill1.BaseFixedPoint);
					goto L_00CF;
				}
			}
		}
		
		public void OnSkillChange(Skill skill)
		{
			NetState state1;
			if (skill == this.m_Highest)
			{
				this.m_Highest = null;
 
			}
			else
			{
				if ((this.m_Highest != null) && (skill.BaseFixedPoint > this.m_Highest.BaseFixedPoint))
				{
					this.m_Highest = skill;
 
				}
 
			}
			this.m_Owner.OnSkillInvalidated(skill);
			state1 = this.m_Owner.NetState;
			if (state1 != null)
			{
				state1.Send(new SkillChange(skill));
 
			}
 
		} 

		public void Serialize(GenericWriter writer)
		{
			int num1;
			Skill skill1;
			this.m_Total = 0;
			writer.Write(3);
			writer.Write(this.m_Cap);
			writer.Write(this.m_Skills.Length);
			for (num1 = 0; (num1 < this.m_Skills.Length); num1 = (num1 + 1))
			{
				skill1 = this.m_Skills[num1];
				if (skill1 == null)
				{
					writer.Write(255);
 
				}
				else
				{
					skill1.Serialize(writer);
					this.m_Total = (this.m_Total + skill1.BaseFixedPoint);
 
				}
 
			}
 
		} 

		public override string ToString()
		{
			return "..."; 
		} 

		public static bool UseSkill(Mobile from, int skillID)
		{
			SkillInfo info1;
			if (!from.CheckAlive())
			{
				return false; 
			}
			if (!from.Region.OnSkillUse(from, skillID))
			{
				return false; 
			}
			if (!from.AllowSkillUse(skillID))
			{
				return false; 
			}
			if ((skillID >= 0) && (skillID < SkillInfo.Table.Length))
			{
				info1 = SkillInfo.Table[skillID];
				if (info1.Callback != null)
				{
					if (DateTime.op_LessThanOrEqual(from.NextSkillTime, DateTime.Now) && (from.Spell == null))
					{
						from.DisruptiveAction();
						from.NextSkillTime = DateTime.op_Addition(DateTime.Now, info1.Callback.Invoke(from));
						return true; 
					}
					from.SendSkillMessage();
					goto L_0095;
 
				}
				from.SendLocalizedMessage(500014);
 
			}
 
			L_0095:
				return false; 
		} 

		public static bool UseSkill(Mobile from, SkillName name)
		{
			return Skills.UseSkill(from, name); 
		} 
		
		public Skill Alchemy { get { return this[0]; } set { } }
		public Skill Anatomy { get { return this[1]; } set { } }
		public Skill AnimalLore { get { return this[2]; } set { } }
		public Skill AnimalTaming { get { return this[35]; } set { } }
		public Skill Archery { get { return this[31]; } set { } }
		public Skill ArmsLore { get { return this[4]; } set { } }
		public Skill Begging { get { return this[6]; } set { } }
		public Skill Blacksmith { get { return this[7]; } set { } }
		public Skill Camping { get { return this[10]; } set { } }
		public int Cap { get { return this.m_Cap; } set { this.m_Cap = value; } }
		public Skill Carpentry { get { return this[11]; } set { } }
		public Skill Cartography { get { return this[12]; } set { } }
		public Skill Chivalry { get { return this[51]; } set { } }
		public Skill Cooking { get { return this[13]; } set { } }
		public Skill DetectHidden { get { return this[14]; } set { } }
		public Skill Discordance { get { return this[15]; } set { } }
		public Skill EvalInt { get { return this[16]; } set { } }
		public Skill Fencing { get { return this[42]; } set { } }
		public Skill Fishing { get { return this[18]; } set { } }
		public Skill Fletching { get { return this[8]; } set { } }
		public Skill Focus { get { return this[50]; } set { } }
		public Skill Forensics { get { return this[19]; } set { } }
		public Skill Healing { get { return this[17]; } set { } }
		public Skill Herding { get { return this[20]; } set { } }
		public Skill Hiding { get { return this[21]; } set { } }
		public Skill Highest 
		{
			get
			{
				Skill skill1;
				int num1;
				int num2;
				Skill skill2;
				if (this.m_Highest == null)
				{
					skill1 = null;
					num1 = -2147483648;
					for (num2 = 0; (num2 < this.m_Skills.Length); num2 = (num2 + 1))
					{
						skill2 = this.m_Skills[num2];
						if ((skill2 != null) && (skill2.BaseFixedPoint > num1))
						{
							num1 = skill2.BaseFixedPoint;
							skill1 = skill2;
 
						}
 
					}
					if ((skill1 == null) && (this.m_Skills.Length > 0))
					{
						skill1 = this[0];
 
					}
					this.m_Highest = skill1;
 
				}
				return this.m_Highest;
			}
		}
		public Skill Inscribe { get { return this[23]; } set { } }
		public Skill this[int skillID] 
		{ 
			get
			{
				Skill skill1;
				if ((skillID < 0) || (skillID >= this.m_Skills.Length))
				{
					return null; 
				}
				skill1 = this.m_Skills[skillID];
				if (skill1 == null)
				{
					skill1 = new Skill(this, SkillInfo.Table[skillID], 0, 1000, 0);
					this.m_Skills[skillID] = new Skill(this, SkillInfo.Table[skillID], 0, 1000, 0);
 
				}
				return skill1;
			}
		}
		public Skill this[SkillName name] 
		{ 
			get
			{
				return this[name];
			}
		}
		public Skill ItemID { get { return this[3]; } set { } }
		public int Length { get { return this.m_Skills.Length; } }
		public Skill Lockpicking { get { return this[24]; } set { } }
		public Skill Lumberjacking { get { return this[44]; } set { } }
		public Skill Macing { get { return this[41]; } set { } }
		public Skill Magery { get { return this[25]; } set { } }
		public Skill MagicResist { get { return this[26]; } set { } }
		public Skill Meditation { get { return this[46]; } set { } }
		public Skill Mining { get { return this[45]; } set { } }
		public Skill Musicianship { get { return this[29]; } set { } }
		public Skill Necromancy { get { return this[49]; } set { } }
		public Mobile Owner { get { return this.m_Owner; } }
		public Skill Parry { get { return this[5]; } set { } }
		public Skill Peacemaking { get { return this[9]; } set { } }
		public Skill Poisoning { get { return this[30]; } set { } }
		public Skill Provocation { get { return this[22]; } set { } }
		public Skill RemoveTrap { get { return this[48]; } set { } }
		public Skill Snooping { get { return this[28]; } set { } }
		public Skill SpiritSpeak { get { return this[32]; } set { } }
		public Skill Stealing { get { return this[33]; } set { } }
		public Skill Stealth { get { return this[47]; } set { } }
		public Skill Swords { get { return this[40]; } set { } }
		public Skill Tactics { get { return this[27]; } set { } }
		public Skill Tailoring { get { return this[34]; } set { } }
		public Skill TasteID { get { return this[36]; } set { } }
		public Skill Tinkering { get { return this[37]; } set { } }
		public int Total { get { return this.m_Total; } set { this.m_Total = value; } }
		public Skill Tracking { get { return this[38]; } set { } }
		public Skill Veterinary { get { return this[39]; } set { } }
		public Skill Wrestling { get { return this[43]; } set { } }

		private int m_Cap;
		private Skill m_Highest;
		private Mobile m_Owner;
		private Skill[] m_Skills;
		private int m_Total;
	} 

	public class SkillInfo
	{
		static SkillInfo()
		{
			SkillInfo[] array1;
			array1 = new SkillInfo[52];
			array1[0] = new SkillInfo(0, "Alchemy", 0, 5, 5, "Alchemist", null, 0, 0.5, 0.5, 1);
			array1[1] = new SkillInfo(1, "Anatomy", 0, 0, 0, "Healer", null, 0.15, 0.15, 0.7, 1);
			array1[2] = new SkillInfo(2, "Animal Lore", 0, 0, 0, "Ranger", null, 0, 0, 1, 1);
			array1[3] = new SkillInfo(3, "Item Identification", 0, 0, 0, "Merchant", null, 0, 0, 1, 1);
			array1[4] = new SkillInfo(4, "Arms Lore", 0, 0, 0, "Warrior", null, 0.75, 0.15, 0.1, 1);
			array1[5] = new SkillInfo(5, "Parrying", 7.5, 2.5, 0, "Warrior", null, 0.75, 0.25, 0, 1);
			array1[6] = new SkillInfo(6, "Begging", 0, 0, 0, "Beggar", null, 0, 0, 0, 1);
			array1[7] = new SkillInfo(7, "Blacksmithy", 10, 0, 0, "Smith", null, 1, 0, 0, 1);
			array1[8] = new SkillInfo(8, "Bowcraft/Fletching", 6, 16, 0, "Bowyer", null, 0.6, 1.6, 0, 1);
			array1[9] = new SkillInfo(9, "Peacemaking", 0, 0, 0, "Bard", null, 0, 0, 0, 1);
			array1[10] = new SkillInfo(10, "Camping", 20, 15, 15, "Ranger", null, 2, 1.5, 1.5, 1);
			array1[11] = new SkillInfo(11, "Carpentry", 20, 5, 0, "Carpenter", null, 2, 0.5, 0, 1);
			array1[12] = new SkillInfo(12, "Cartography", 0, 7.5, 7.5, "Cartographer", null, 0, 0.75, 0.75, 1);
			array1[13] = new SkillInfo(13, "Cooking", 0, 20, 30, "Chef", null, 0, 2, 3, 1);
			array1[14] = new SkillInfo(14, "Detecting Hidden", 0, 0, 0, "Scout", null, 0, 0.4, 0.6, 1);
			array1[15] = new SkillInfo(15, "Discordance", 0, 2.5, 2.5, "Bard", null, 0, 0.25, 0.25, 1);
			array1[16] = new SkillInfo(16, "Evaluating Intelligence", 0, 0, 0, "Scholar", null, 0, 0, 1, 1);
			array1[17] = new SkillInfo(17, "Healing", 6, 6, 8, "Healer", null, 0.6, 0.6, 0.8, 1);
			array1[18] = new SkillInfo(18, "Fishing", 0, 0, 0, "Fisherman", null, 0.5, 0.5, 0, 1);
			array1[19] = new SkillInfo(19, "Forensic Evaluation", 0, 0, 0, "Detective", null, 0, 0.2, 0.8, 1);
			array1[20] = new SkillInfo(20, "Herding", 16.25, 6.25, 2.5, "Shepherd", null, 1.625, 0.625, 0.25, 1);
			array1[21] = new SkillInfo(21, "Hiding", 0, 0, 0, "Rogue", null, 0, 0.8, 0.2, 1);
			array1[22] = new SkillInfo(22, "Provocation", 0, 4.5, 0.5, "Bard", null, 0, 0.45, 0.05, 1);
			array1[23] = new SkillInfo(23, "Inscription", 0, 2, 8, "Scribe", null, 0, 0.2, 0.8, 1);
			array1[24] = new SkillInfo(24, "Lockpicking", 0, 25, 0, "Rogue", null, 0, 2, 0, 1);
			array1[25] = new SkillInfo(25, "Magery", 0, 0, 15, "Mage", null, 0, 0, 1.5, 1);
			array1[26] = new SkillInfo(26, "Resisting Spells", 0, 0, 0, "Mage", null, 0.25, 0.25, 0.5, 1);
			array1[27] = new SkillInfo(27, "Tactics", 0, 0, 0, "Warrior", null, 0, 0, 0, 1);
			array1[28] = new SkillInfo(28, "Snooping", 0, 25, 0, "Pickpocket", null, 0, 2.5, 0, 1);
			array1[29] = new SkillInfo(29, "Musicianship", 0, 0, 0, "Bard", null, 0, 0.8, 0.2, 1);
			array1[30] = new SkillInfo(30, "Poisoning", 0, 4, 16, "Assassin", null, 0, 0.4, 1.6, 1);
			array1[31] = new SkillInfo(31, "Archery", 2.5, 7.5, 0, "Archer", null, 0.25, 0.75, 0, 1);
			array1[32] = new SkillInfo(32, "Spirit Speak", 0, 0, 0, "Medium", null, 0, 0, 1, 1);
			array1[33] = new SkillInfo(33, "Stealing", 0, 10, 0, "Rogue", null, 0, 1, 0, 1);
			array1[34] = new SkillInfo(34, "Tailoring", 3.75, 16.25, 5, "Tailor", null, 0.38, 1.63, 0.5, 1);
			array1[35] = new SkillInfo(35, "Animal Taming", 14, 2, 4, "Tamer", null, 1.4, 0.2, 0.4, 1);
			array1[36] = new SkillInfo(36, "Taste Identification", 0, 0, 0, "Chef", null, 0.2, 0, 0.8, 1);
			array1[37] = new SkillInfo(37, "Tinkering", 5, 2, 3, "Tinker", null, 0.5, 0.2, 0.3, 1);
			array1[38] = new SkillInfo(38, "Tracking", 0, 12.5, 12.5, "Ranger", null, 0, 1.25, 1.25, 1);
			array1[39] = new SkillInfo(39, "Veterinary", 8, 4, 8, "Veterinarian", null, 0.8, 0.4, 0.8, 1);
			array1[40] = new SkillInfo(40, "Swordsmanship", 7.5, 2.5, 0, "Swordsman", null, 0.75, 0.25, 0, 1);
			array1[41] = new SkillInfo(41, "Mace Fighting", 9, 1, 0, "Armsman", null, 0.9, 0.1, 0, 1);
			array1[42] = new SkillInfo(42, "Fencing", 4.5, 5.5, 0, "Fencer", null, 0.45, 0.55, 0, 1);
			array1[43] = new SkillInfo(43, "Wrestling", 9, 1, 0, "Wrestler", null, 0.9, 0.1, 0, 1);
			array1[44] = new SkillInfo(44, "Lumberjacking", 20, 0, 0, "Lumberjack", null, 2, 0, 0, 1);
			array1[45] = new SkillInfo(45, "Mining", 20, 0, 0, "Miner", null, 2, 0, 0, 1);
			array1[46] = new SkillInfo(46, "Meditation", 0, 0, 0, "Stoic", null, 0, 0, 0, 1);
			array1[47] = new SkillInfo(47, "Stealth", 0, 0, 0, "Rogue", null, 0, 0, 0, 1);
			array1[48] = new SkillInfo(48, "Remove Trap", 0, 0, 0, "Rogue", null, 0, 0, 0, 1);
			array1[49] = new SkillInfo(49, "Necromancy", 0, 0, 0, "Necromancer", null, 0, 0, 0, 1);
			array1[50] = new SkillInfo(50, "Focus", 0, 0, 0, "Stoic", null, 0, 0, 0, 1);
			array1[51] = new SkillInfo(51, "Chivalry", 0, 0, 0, "Paladin", null, 0, 0, 0, 1);
			SkillInfo.m_Table = array1;
		}

		public SkillInfo(int skillID, string name, double strScale, double dexScale, double intScale, string title, SkillUseCallback callback, double strGain, double dexGain, double intGain, double gainFactor) : base()
		{
			this.m_Name = name;
			this.m_Title = title;
			this.m_SkillID = skillID;
			this.m_StrScale = (strScale / 100);
			this.m_DexScale = (dexScale / 100);
			this.m_IntScale = (intScale / 100);
			this.m_Callback = callback;
			this.m_StrGain = strGain;
			this.m_DexGain = dexGain;
			this.m_IntGain = intGain;
			this.m_GainFactor = gainFactor;
			this.m_StatTotal = ((strScale + dexScale) + intScale);
		} 
		
		public SkillUseCallback Callback { 
			get
			{
				return this.m_Callback;
			}
			set
			{
				this.m_Callback = value;
			}
		}

		public double DexGain 
		{ 
			get
			{
				return this.m_DexGain;
			}
			set
			{
				this.m_DexGain = value;
			}
		}

		public double DexScale 
		{ 
			get
			{
				return this.m_DexScale;
			}
			set
			{
				this.m_DexScale = value;
			}
		}

		public double GainFactor 
		{ 
			get
			{
				return this.m_GainFactor;
			}
			set
			{
				this.m_GainFactor = value;
			}
		}

		public double IntGain 
		{ 
			get
			{
				return this.m_IntGain;
			}
			set
			{
				this.m_IntGain = value;
			}
		}

		public double IntScale 
		{ 
			get
			{
				return this.m_IntScale;
			}
			set
			{
				this.m_IntScale = value;
			}
		}

		public string Name 
		{ 
			get
			{
				return this.m_Name;
			}
			set
			{
				this.m_Name = value;
			}
		}

		public int SkillID 
		{ 
			get
			{
				return this.m_SkillID;
			}
		}

		public double StatTotal 
		{ 
			get
			{
				return this.m_StatTotal;
			}
			set
			{
				this.m_StatTotal = value;
			}
		}

		public double StrGain 
		{ 
			get
			{
				return this.m_StrGain;
			}
			set
			{
				this.m_StrGain = value;
			}
		}

		public double StrScale 
		{ 
			get
			{
				return this.m_StrScale;
			}
			set
			{
				this.m_StrScale = value;
			}
		}

		public static SkillInfo[] Table 
		{ 
			get
			{
				return SkillInfo.m_Table;
			}
			set
			{
				SkillInfo.m_Table = value;
			}
		}

		public string Title 
		{ 
			get
			{
				return this.m_Title;
			}
			set
			{
				this.m_Title = value;
			}
		}

		private SkillUseCallback m_Callback;
		private double m_DexGain;
		private double m_DexScale;
		private double m_GainFactor;
		private double m_IntGain;
		private double m_IntScale;
		private string m_Name;
		private int m_SkillID;
		private double m_StatTotal;
		private double m_StrGain;
		private double m_StrScale;
		private static SkillInfo[] m_Table;
		private string m_Title;
	}

	public struct SkillNameValue
	{
		public SkillNameValue(SkillName name, int value)
		{
			this.m_Name = name;
			this.m_Value = value;
 		} 

		public SkillName Name { 
			get
			{
				return this.m_Name;
			}
		}

		public int Value { 
			get
			{
				return this.m_Value;
			}
		}

		private SkillName m_Name;
		private int m_Value;
 
	}
 

}