using System;
using System.Collections;
using System.IO;

namespace Server
{
	public class TileMatrix
	{
		public TileMatrix(Map owner, int fileIndex, int mapID, int width, int height) : base()
		{
			int num1;
			TileMatrix matrix1;
			string text1;
			string text2;
			string text3;
			int num2;
			int num3;
			object[] array1;
			this.m_FileShare = new ArrayList();
			for (num1 = 0; (num1 < TileMatrix.m_Instances.Count); num1 = (num1 + 1))
			{
				matrix1 = ((TileMatrix) TileMatrix.m_Instances[num1]);
				if (matrix1.m_FileIndex == fileIndex)
				{
					matrix1.m_FileShare.Add(this);
					this.m_FileShare.Add(matrix1);
 
				}
 
			}
			TileMatrix.m_Instances.Add(this);
			this.m_FileIndex = fileIndex;
			this.m_Width = width;
			this.m_Height = height;
			this.m_BlockWidth = (width >> 3);
			this.m_BlockHeight = (height >> 3);
			this.m_Owner = owner;
			if (fileIndex != 127)
			{
				array1 = new object[1];
				array1[0] = fileIndex;
				text1 = Core.FindDataFile("map{0}.mul", array1);
				if (File.Exists(text1))
				{
					this.m_Map = new FileStream(text1, 3, 1, 3);
 
				}
				array1 = new object[1];
				array1[0] = fileIndex;
				text2 = Core.FindDataFile("staidx{0}.mul", array1);
				if (File.Exists(text2))
				{
					this.m_Index = new FileStream(text2, 3, 1, 3);
					this.m_IndexReader = new BinaryReader(this.m_Index);
 
				}
				array1 = new object[1];
				array1[0] = fileIndex;
				text3 = Core.FindDataFile("statics{0}.mul", array1);
				if (File.Exists(text3))
				{
					this.m_Statics = new FileStream(text3, 3, 1, 3);
 
				}
 
			}
			//TRF this.m_EmptyStaticBlock = new Tile[][][8];
			this.m_EmptyStaticBlock = new Tile[8][][];
			for (num2 = 0; (num2 < 8); num2 = (num2 + 1))
			{
				//TRF this.m_EmptyStaticBlock[num2] = new Tile[][8];
				this.m_EmptyStaticBlock[num2] = new Tile[8][];
				for (num3 = 0; (num3 < 8); num3 = (num3 + 1))
				{
					this.m_EmptyStaticBlock[num2][num3] = new Tile[0];
 
				}
 
			}
			this.m_InvalidLandBlock = new Tile[196];
			//TRF this.m_LandTiles = new Tile[][][this.m_BlockWidth];
			this.m_LandTiles = new Tile[this.m_BlockWidth][][];
			//TRF this.m_StaticTiles = new Tile[][][][][this.m_BlockWidth];
			this.m_StaticTiles = new Tile[this.m_BlockWidth][][][][];
			//TRF this.m_StaticPatches = new int[][this.m_BlockWidth];
			this.m_StaticPatches = new int[this.m_BlockWidth][];
			//TRF this.m_LandPatches = new int[][this.m_BlockWidth];
			this.m_LandPatches = new int[this.m_BlockWidth][];
			this.m_Patch = new TileMatrixPatch(this, mapID);
 		}

		// TODO: Make this non-platform specific
		private extern static int _lread(IntPtr hFile, void* lpBuffer, int wBytes);

		public void Dispose()
		{
				if (this.m_Map != null)
		  {
			  this.m_Map.Close();
 
		  }
			if (this.m_Statics != null)
			{
				this.m_Statics.Close();
 
			}
			if (this.m_IndexReader != null)
			{
				this.m_IndexReader.Close();
 
			}
 
		} 

		public void Force()
		{
				if ((ScriptCompiler.Assemblies == null) || (ScriptCompiler.Assemblies.Length == 0))
		  {
			  throw new Exception();
 
		  }
 
		} 

		public Tile[] GetLandBlock(int x, int y)
		{
				Tile[] array1;
			int num1;
			TileMatrix matrix1;
			Tile[][] array2;
			int[] array3;
			if (((x < 0) || (y < 0)) || (((x >= this.m_BlockWidth) || (y >= this.m_BlockHeight)) || (this.m_Map == null)))
			{
				return this.m_InvalidLandBlock; 
			}
			if (this.m_LandTiles[x] == null)
			{
				//TRF this.m_LandTiles[x] = new Tile[][this.m_BlockHeight];
				this.m_LandTiles[x] = new Tile[this.m_BlockHeight][];
			}
			array1 = this.m_LandTiles[x][y];
			if (array1 == null)
			{
				for (num1 = 0; ((array1 == null) && (num1 < this.m_FileShare.Count)); num1 = (num1 + 1))
				{
					matrix1 = ((TileMatrix) this.m_FileShare[num1]);
					if (((x >= 0) && (x < matrix1.m_BlockWidth)) && ((y >= 0) && (y < matrix1.m_BlockHeight)))
					{
						array2 = matrix1.m_LandTiles[x];
						if (array2 != null)
						{
							array1 = array2[y];
 
						}
						if (array1 != null)
						{
							array3 = matrix1.m_LandPatches[x];
							if ((array3 != null) && ((array3[(y >> 5)] & (1 << ((y & 31) & 31))) != 0))
							{
								array1 = null;
 
							}
 
						}
 
					}
 
				}
				if (array1 == null)
				{
					array1 = this.ReadLandBlock(x, y);
 
				}
				this.m_LandTiles[x][y] = array1;
 
			}
			return array1; 
		} 

		public Tile GetLandTile(int x, int y)
		{
				Tile[] array1;
			array1 = this.GetLandBlock((x >> 3), (y >> 3));
			return array1[(((y & 7) << 3) + (x & 7))]; 
		} 

		public Tile[][][] GetStaticBlock(int x, int y)
		{
				Tile[][][] array1;
			int num1;
			TileMatrix matrix1;
			Tile[][][][] array2;
			int[] array3;
			if ((((x < 0) || (y < 0)) || ((x >= this.m_BlockWidth) || (y >= this.m_BlockHeight))) || ((this.m_Statics == null) || (this.m_Index == null)))
			{
				return this.m_EmptyStaticBlock; 
			}
			if (this.m_StaticTiles[x] == null)
			{
				//TRF this.m_StaticTiles[x] = new Tile[][][][this.m_BlockHeight];
				this.m_StaticTiles[x] = new Tile[this.m_BlockHeight][][][];
			}
			array1 = this.m_StaticTiles[x][y];
			if (array1 == null)
			{
				for (num1 = 0; ((array1 == null) && (num1 < this.m_FileShare.Count)); num1 = (num1 + 1))
				{
					matrix1 = ((TileMatrix) this.m_FileShare[num1]);
					if (((x >= 0) && (x < matrix1.m_BlockWidth)) && ((y >= 0) && (y < matrix1.m_BlockHeight)))
					{
						array2 = matrix1.m_StaticTiles[x];
						if (array2 != null)
						{
							array1 = array2[y];
 
						}
						if (array1 != null)
						{
							array3 = matrix1.m_StaticPatches[x];
							if ((array3 != null) && ((array3[(y >> 5)] & (1 << ((y & 31) & 31))) != 0))
							{
								array1 = null;
 
							}
 
						}
 
					}
 
				}
				if (array1 == null)
				{
					array1 = this.ReadStaticBlock(x, y);
 
				}
				this.m_StaticTiles[x][y] = array1;
 
			}
			return array1; 
		}
		
		public Tile[] GetStaticTiles(int x, int y)
		{
				Tile[][][] array1;
			array1 = this.GetStaticBlock((x >> 3), (y >> 3));
			return array1[(x & 7)][(y & 7)]; 
		} 

		public Tile[] GetStaticTiles(int x, int y, bool multis)
		{
				Tile[][][] array1;
			IPooledEnumerable enumerable1;
			bool flag1;
			Tile[] array2;
			IEnumerator enumerator1;
			IDisposable disposable1;
			array1 = this.GetStaticBlock((x >> 3), (y >> 3));
			if (multis)
			{
				enumerable1 = this.m_Owner.GetMultiTilesAt(x, y);
				if (enumerable1 == NullEnumerable.Instance)
				{
					return array1[(x & 7)][(y & 7)]; 
				}
				flag1 = false;
				enumerator1 = enumerable1.GetEnumerator();
				try
				{
					while (enumerator1.MoveNext())
					{
						array2 = ((Tile[]) enumerator1.Current);
						if (!flag1)
						{
							flag1 = true;
 
						}
						TileMatrix.m_TilesList.AddRange(array2);
 
					}
 
				}
				finally
				{
					disposable1 = (enumerator1 as IDisposable);
					if (disposable1 != null)
					{
						disposable1.Dispose();
 
					}
 
				}
				enumerable1.Free();
				if (!flag1)
				{
					return array1[(x & 7)][(y & 7)]; 
				}
				TileMatrix.m_TilesList.AddRange(array1[(x & 7)][(y & 7)]);
				return TileMatrix.m_TilesList.ToArray(); 
			}
			return array1[(x & 7)][(y & 7)]; 
		} 

		private Tile[] ReadLandBlock(int x, int y)
		{
			Tile[] array1;
			/* TRF
			ref Tile objRef1;
			*/
			Tile[] array2;
			try
			{
				this.m_Map.Seek(((long) ((((x * this.m_BlockHeight) + y) * 196) + 4)), 0);
				array1 = new Tile[64];
				try
				{
					/* TRF
					objRef1 = &(array1[0]);
					TileMatrix._lread(this.m_Map.Handle, objRef1, 192);
					*/
					TileMatrix._lread(this.m_Map.Handle, &(array1[0]), 192);
 				}
				finally
				{
					/* TRF
					objRef1 = 0;
					*/
				}
				array2 = array1;
 
			}
			catch (object obj1)
			{
				if (DateTime.op_GreaterThanOrEqual(DateTime.Now, this.m_NextLandWarning))
				{
					Console.WriteLine("Warning: Land EOS for {0} ({1}, {2})", this.m_Owner, x, y);
					this.m_NextLandWarning = DateTime.op_Addition(DateTime.Now, TimeSpan.FromMinutes(1));
 
				}
				array2 = this.m_InvalidLandBlock;
 
			}
			return array2; 
		} 

		private Tile[][][] ReadStaticBlock(int x, int y)
		{
				int num1;
			int num2;
			int num3;
			StaticTile[] array1;
			/* TRF
			ref StaticTile objRef1;
			*/
			StaticTile* objRef1;
			int num4;
			int num5;
			TileList[][] array2;
			StaticTile* ptr1;
			StaticTile* ptr2;
			Tile[][][] array3;
			int num6;
			int num7;
			Tile[][][] array4;
			try
			{
				this.m_IndexReader.BaseStream.Seek(((long) (((x * this.m_BlockHeight) + y) * 12)), 0);
				num1 = this.m_IndexReader.ReadInt32();
				num2 = this.m_IndexReader.ReadInt32();
				if ((num1 < 0) || (num2 <= 0))
				{
					array4 = this.m_EmptyStaticBlock;
					goto L_01F7;
 
				}
				num3 = (num2 / 7);
				this.m_Statics.Seek(((long) num1), 0);
				if (TileMatrix.m_TileBuffer.Length < num3)
				{
					TileMatrix.m_TileBuffer = new StaticTile[num3];
 
				}
				array1 = TileMatrix.m_TileBuffer;
				try
				{
					objRef1 = &(array1[0]);
					TileMatrix._lread(this.m_Statics.Handle, objRef1, num2);
					if (TileMatrix.m_Lists == null)
					{
						//TRF TileMatrix.m_Lists = new TileList[][8];
						TileMatrix.m_Lists = new TileList[8][];
						for (num4 = 0; (num4 < 8); num4 = (num4 + 1))
						{
							TileMatrix.m_Lists[num4] = new TileList[8];
							for (num5 = 0; (num5 < 8); num5 = (num5 + 1))
							{
								TileMatrix.m_Lists[num4][num5] = new TileList();
 
							}
 
						}
 
					}
					array2 = TileMatrix.m_Lists;
					ptr1 = objRef1;
					ptr2 = (objRef1 + (num3 * sizeof(StaticTile)));
					while ((ptr1 < ptr2))
					{
						array2[(ptr1.m_X & 7)][(ptr1.m_Y & 7)].Add(((ptr1.m_ID & 16383) + 16384), ptr1.m_Z);
						ptr1 = (ptr1 + sizeof(StaticTile));
 
					}
					//TRF array3 = new Tile[][][8];
					array3 = new Tile[8][][];
					for (num6 = 0; (num6 < 8); num6 = (num6 + 1))
					{
						//TRF array3[num6] = new Tile[][8];
						array3[num6] = new Tile[8][];
						for (num7 = 0; (num7 < 8); num7 = (num7 + 1))
						{
							array3[num6][num7] = array2[num6][num7].ToArray();
 
						}
 
					}
					array4 = array3;
					goto L_01F7;
 
				}
				finally
				{
					objRef1 = 0;
 
				}
 
			}
			catch (EndOfStreamException exception1)
			{
				if (DateTime.op_GreaterThanOrEqual(DateTime.Now, this.m_NextStaticWarning))
				{
					Console.WriteLine("Warning: Static EOS for {0} ({1}, {2})", this.m_Owner, x, y);
					this.m_NextStaticWarning = DateTime.op_Addition(DateTime.Now, TimeSpan.FromMinutes(1));
 
				}
				array4 = this.m_EmptyStaticBlock;
 
			}
 
			L_01F7:
				return array4; 
		}
		
		public void SetLandBlock(int x, int y, Tile[] value)
		{
				int[] array1;
			IntPtr ptr1;
			if (((x < 0) || (y < 0)) || ((x >= this.m_BlockWidth) || (y >= this.m_BlockHeight)))
			{
				return; 
			}
			if (this.m_LandTiles[x] == null)
			{
				//TRF this.m_LandTiles[x] = new Tile[][this.m_BlockHeight];
				this.m_LandTiles[x] = new Tile[this.m_BlockHeight][];
			}
			this.m_LandTiles[x][y] = value;
			if (this.m_LandPatches[x] == null)
			{
				this.m_LandPatches[x] = new int[((this.m_BlockHeight + 31) >> 5)];
 
			}
			array1 = this.m_LandPatches[x];
			ptr1 = (y >> 5);
			this.m_LandPatches[x][(y >> 5)] = (array1[ptr1] | (1 << ((y & 31) & 31)));
 
		} 

		public void SetStaticBlock(int x, int y, Tile[][][] value)
		{
				int[] array1;
			IntPtr ptr1;
			if (((x < 0) || (y < 0)) || ((x >= this.m_BlockWidth) || (y >= this.m_BlockHeight)))
			{
				return; 
			}
			if (this.m_StaticTiles[x] == null)
			{
				//TRF this.m_StaticTiles[x] = new Tile[][][][this.m_BlockHeight];
				this.m_StaticTiles[x] = new Tile[this.m_BlockHeight][][][];
			}
			this.m_StaticTiles[x][y] = value;
			if (this.m_StaticPatches[x] == null)
			{
				this.m_StaticPatches[x] = new int[((this.m_BlockHeight + 31) >> 5)];
 
			}
			array1 = this.m_StaticPatches[x];
			ptr1 = (y >> 5);
			this.m_StaticPatches[x][(y >> 5)] = (array1[ptr1] | (1 << ((y & 31) & 31)));
 
		} 
		
		public int BlockHeight { 
			get
			{
				return this.m_BlockHeight;
			}
		}

		public int BlockWidth 
		{ 
			get
			{
				return this.m_BlockWidth;
			}
		}

		public FileStream DataStream { 
			get
			{
				return this.m_Statics;
			}
			set
			{
				this.m_Statics = value;
			}
		}

		public Tile[][][] EmptyStaticBlock 
		{ 
			get
			{
				return this.m_EmptyStaticBlock;
			}
		}

		public bool Exists 
		{ 
			get
			{
				if ((this.m_Map != null) && (this.m_Index != null))
				{
					return (this.m_Statics != null); 
				}
				return false;
			}
		}

		public int Height 
		{ 
			get
			{
				return this.m_Height;
			}
		}

		public BinaryReader IndexReader 
		{ 
			get
			{
				return this.m_IndexReader;
			}
			set
			{
				this.m_IndexReader = value;
			}
		}

		public FileStream IndexStream 
		{ 
			get
			{
				return this.m_Index;
			}
			set
			{
				this.m_Index = value;
			}
		}

		public FileStream MapStream 
		{ 
			get
			{
				return this.m_Map;
			}
			set
			{
				this.m_Map = value;
			}
		}

		public Map Owner 
		{ 
			get
			{
				return this.m_Owner;
			}
		}

		public TileMatrixPatch Patch 
		{ 
			get
			{
				return this.m_Patch;
			}
		}

		public int Width 
		{ 
			get
			{
				return this.m_Width;
			}
		}

		private int m_BlockHeight;
		private int m_BlockWidth;
		private Tile[][][] m_EmptyStaticBlock;
		private int m_FileIndex;
		private ArrayList m_FileShare;
		private int m_Height;
		private FileStream m_Index;
		private BinaryReader m_IndexReader;
		private static ArrayList m_Instances = new ArrayList();
		private Tile[] m_InvalidLandBlock;
		private int[][] m_LandPatches;
		private Tile[][][] m_LandTiles;
		private static TileList[][] m_Lists;
		private FileStream m_Map;
		private DateTime m_NextLandWarning;
		private DateTime m_NextStaticWarning;
		private Map m_Owner;
		private TileMatrixPatch m_Patch;
		private int[][] m_StaticPatches;
		private FileStream m_Statics;
		private Tile[][][][][] m_StaticTiles;
		private static StaticTile[] m_TileBuffer = new StaticTile[128];
		private static TileList m_TilesList = new TileList();
		private int m_Width;
	}

	public class TileMatrixPatch
	{
		public TileMatrixPatch(TileMatrix matrix, int index) : base()
		{
			string text1;
			string text2;
			string text3;
			string text4;
			string text5;
			object[] array1;
			if (!TileMatrixPatch.m_Enabled)
			{
				return; 
			}
			array1 = new object[1];
			array1[0] = index;
			text1 = Core.FindDataFile("mapdif{0}.mul", array1);
			array1 = new object[1];
			array1[0] = index;
			text2 = Core.FindDataFile("mapdifl{0}.mul", array1);
			if (File.Exists(text1) && File.Exists(text2))
			{
				this.m_LandBlocks = this.PatchLand(matrix, text1, text2);
 
			}
			array1 = new object[1];
			array1[0] = index;
			text3 = Core.FindDataFile("stadif{0}.mul", array1);
			array1 = new object[1];
			array1[0] = index;
			text4 = Core.FindDataFile("stadifl{0}.mul", array1);
			array1 = new object[1];
			array1[0] = index;
			text5 = Core.FindDataFile("stadifi{0}.mul", array1);
			if ((File.Exists(text3) && File.Exists(text4)) && File.Exists(text5))
			{
				this.m_StaticBlocks = this.PatchStatics(matrix, text3, text4, text5);
 
			}
 
		} 

		// TODO: Fix me!
		private extern static int _lread(IntPtr hFile, void* lpBuffer, int wBytes);

		private int PatchLand(TileMatrix matrix, string dataPath, string indexPath)
		{
			FileStream stream1;
			FileStream stream2;
			BinaryReader reader1;
			int num1;
			int num2;
			int num3;
			int num4;
			int num5;
			Tile[] array1;
			//TRF ref Tile objRef1;
			Tile* objRef1;
			int num6;
			stream1 = new FileStream(dataPath, 3, 1, 1);
			try
			{
				stream2 = new FileStream(indexPath, 3, 1, 1);
				try
				{
					reader1 = new BinaryReader(stream2);
					num1 = ((int) (reader1.BaseStream.Length / ((long) 4)));
					for (num2 = 0; (num2 < num1); num2 = (num2 + 1))
					{
						num3 = reader1.ReadInt32();
						num4 = (num3 / matrix.BlockHeight);
						num5 = (num3 % matrix.BlockHeight);
						stream1.Seek(((long) 4), 1);
						array1 = new Tile[64];
						try
						{
							objRef1 = &(array1[0]);
							TileMatrixPatch._lread(stream1.Handle, objRef1, 192);
 
						}
						finally
						{
							objRef1 = 0;
 
						}
						matrix.SetLandBlock(num4, num5, array1);
 
					}
					num6 = num1;
					goto L_00B6;
 
				}
				finally
				{
					if (stream2 != null)
					{
						stream2.Dispose();
 
					}
 
				}
 
			}
			finally
			{
				if (stream1 != null)
				{
					stream1.Dispose();
 
				}
 
			}
 
			L_00B6:
				return num6; 
		}
		
		private int PatchStatics(TileMatrix matrix, string dataPath, string indexPath, string lookupPath)
		{
				FileStream stream1;
			FileStream stream2;
			FileStream stream3;
			BinaryReader reader1;
			BinaryReader reader2;
			int num1;
			TileList[][] array1;
			int num2;
			int num3;
			int num4;
			int num5;
			int num6;
			int num7;
			int num8;
			int num9;
			int num10;
			StaticTile[] array2;
			//TRF ref StaticTile objRef1;
			StaticTile* objRef1;
			StaticTile* ptr1;
			StaticTile* ptr2;
			Tile[][][] array3;
			int num11;
			int num12;
			int num13;
			stream1 = new FileStream(dataPath, 3, 1, 1);
			try
			{
				stream2 = new FileStream(indexPath, 3, 1, 1);
				try
				{
					stream3 = new FileStream(lookupPath, 3, 1, 1);
					try
					{
						reader1 = new BinaryReader(stream2);
						reader2 = new BinaryReader(stream3);
						num1 = ((int) (reader1.BaseStream.Length / ((long) 4)));
						//TRF array1 = new TileList[][8];
						array1 = new TileList[8][];
						for (num2 = 0; (num2 < 8); num2 = (num2 + 1))
						{
							array1[num2] = new TileList[8];
							for (num3 = 0; (num3 < 8); num3 = (num3 + 1))
							{
								array1[num2][num3] = new TileList();
 
							}
 
						}
						for (num4 = 0; (num4 < num1); num4 = (num4 + 1))
						{
							num5 = reader1.ReadInt32();
							num6 = (num5 / matrix.BlockHeight);
							num7 = (num5 % matrix.BlockHeight);
							num8 = reader2.ReadInt32();
							num9 = reader2.ReadInt32();
							reader2.ReadInt32();
							if ((num8 < 0) || (num9 <= 0))
							{
								matrix.SetStaticBlock(num6, num7, matrix.EmptyStaticBlock);
 
							}
							else
							{
									stream1.Seek(((long) num8), 0);
								num10 = (num9 / 7);
								if (TileMatrixPatch.m_TileBuffer.Length < num10)
								{
									TileMatrixPatch.m_TileBuffer = new StaticTile[num10];
 
								}
								array2 = TileMatrixPatch.m_TileBuffer;
								try
								{
									objRef1 = &(array2[0]);
									TileMatrixPatch._lread(stream1.Handle, objRef1, num9);
									ptr1 = objRef1;
									ptr2 = (objRef1 + (num10 * sizeof(StaticTile)));
									while ((ptr1 < ptr2))
									{
										array1[(ptr1.m_X & 7)][(ptr1.m_Y & 7)].Add(((ptr1.m_ID & 16383) + 16384), ptr1.m_Z);
										ptr1 = (ptr1 + sizeof(StaticTile));
 
									}
									//TRF array3 = new Tile[][][8];
									array3 = new Tile[8][][];
									for (num11 = 0; (num11 < 8); num11 = (num11 + 1))
									{
										//TRF array3[num11] = new Tile[][8];
										array3[num11] = new Tile[8][];
										for (num12 = 0; (num12 < 8); num12 = (num12 + 1))
										{
											array3[num11][num12] = array1[num11][num12].ToArray();
 
										}
 
									}
									matrix.SetStaticBlock(num6, num7, array3);
 
								}
								finally
								{
									objRef1 = 0;
 
								}
 
							}
 
						}
						num13 = num1;
						goto L_0214;
 
					}
					finally
					{
						if (stream3 != null)
						{
							stream3.Dispose();
 
						}
 
					}
 
				}
				finally
				{
					if (stream2 != null)
					{
						stream2.Dispose();
 
					}
 
				}
 
			}
			finally
			{
				if (stream1 != null)
				{
					stream1.Dispose();
 
				}
 
			}
 
			L_0214:
				return num13; 
		}
		
		public static bool Enabled { 
			get
			{
				return TileMatrixPatch.m_Enabled;
			}
			set
			{
				TileMatrixPatch.m_Enabled = value;
			}
		}

		public int LandBlocks { 
			get
			{
				return this.m_LandBlocks;
			}
		}

		public int StaticBlocks { 
			get
			{
				return this.m_StaticBlocks;
			}
		}

		private static bool m_Enabled = true;
		private int m_LandBlocks;
		private int m_StaticBlocks;
		private static StaticTile[] m_TileBuffer = new StaticTile[128];
	} 
}