using System;
using System.IO;
using System.Net;
using System.Text;
using System.Collections;

namespace Server
{
	public class Utility
	{
		public Utility() : base()
		{
		}

		public static ArrayList BuildArrayList(IEnumerable enumerable)
		{
			IEnumerator enumerator1;
			ArrayList list1;
			enumerator1 = enumerable.GetEnumerator();
			list1 = new ArrayList();
			while (enumerator1.MoveNext())
			{
				list1.Add(enumerator1.Current);
 
			}
			return list1; 
		} 

		public static bool CanMobileFit(int z, Tile[] tiles)
		{
			int num1;
			int num2;
			int num3;
			Tile tile1;
			num1 = 15;
			num2 = z;
			for (num3 = 0; (num3 < tiles.Length); num3 = (num3 + 1))
			{
				tile1 = tiles[num3];
				if (((num2 + num1) > tile1.Z) && (num2 < (tile1.Z + tile1.Height)))
				{
					return false; 
				}
				if ((num1 == 0) && ((tile1.Height == 0) && (num2 == tile1.Z)))
				{
					return false; 
				}
 
			}
			return true; 
		} 

		public static int ClipDyedHue(int hue)
		{
			if (hue < 2)
			{
				return 2; 
			}
			if (hue > 1001)
			{
				return 1001; 
			}
			return hue; 
		} 

		public static int ClipHairHue(int hue)
		{
			if (hue < 1102)
			{
				return 1102; 
			}
			if (hue > 1149)
			{
				return 1149; 
			}
			return hue; 
		} 

		public static int ClipSkinHue(int hue)
		{
			if (hue < 1002)
			{
				return 1002; 
			}
			if (hue > 1058)
			{
				return 1058; 
			}
			return hue; 
		} 

		public static int Dice(int numDice, int numSides, int bonus)
		{
			int num1;
			int num2;
			num1 = 0;
			for (num2 = 0; (num2 < numDice); num2 = (num2 + 1))
			{
				num1 = (num1 + (Utility.Random(numSides) + 1));
 
			}
			num1 = (num1 + bonus);
			return num1; 
		} 

		public static string FixHtml(string str)
		{
			StringBuilder builder1;
			if ((str.IndexOf(60) == -1) && (str.IndexOf(62) == -1))
			{
				return str; 
			}
			builder1 = new StringBuilder(str);
			builder1.Replace(60, 40);
			builder1.Replace(62, 41);
			return builder1.ToString(); 
		} 

		public static void FixPoints(ref Point3D top, ref Point3D bottom)
		{
			int num1;
			int num2;
			int num3;
			if (bottom.m_X < top.m_X)
			{
				num1 = top.m_X;
				top.m_X = bottom.m_X;
				bottom.m_X = num1;
 
			}
			if (bottom.m_Y < top.m_Y)
			{
				num2 = top.m_Y;
				top.m_Y = bottom.m_Y;
				bottom.m_Y = num2;
 
			}
			if (bottom.m_Z < top.m_Z)
			{
				num3 = top.m_Z;
				top.m_Z = bottom.m_Z;
				bottom.m_Z = num3;
 
			}
 
		} 

		public static void FormatBuffer(TextWriter output, Stream input, int length)
		{
			int num1;
			int num2;
			int num3;
			int num4;
			StringBuilder builder1;
			StringBuilder builder2;
			int num5;
			int num6;
			StringBuilder builder3;
			StringBuilder builder4;
			int num7;
			int num8;
			output.WriteLine(" 0 1 2 3 4 5 6 7 8 9 A B C D E F");
			output.WriteLine(" -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --");
			num1 = 0;
			num2 = (length >> 4);
			num3 = (length & 15);
			num4 = 0;
			while ((num4 < num2))
			{
				builder1 = new StringBuilder(49);
				builder2 = new StringBuilder(16);
				for (num5 = 0; (num5 < 16); num5 = (num5 + 1))
				{
					num6 = input.ReadByte();
					builder1.Append(num6.ToString("X2"));
					if (num5 != 7)
					{
						builder1.Append(32);
 
					}
					else
					{
						builder1.Append(" ");
 
					}
					if ((num6 >= 32) && (num6 < 128))
					{
						builder2.Append(((ushort) num6));
 
					}
					else
					{
						builder2.Append(46);
 
					}
 
				}
				output.Write(num1.ToString("X4"));
				output.Write(" ");
				output.Write(builder1.ToString());
				output.Write(" ");
				output.WriteLine(builder2.ToString());
				num4 = (num4 + 1);
				num1 = (num1 + 16);
 
			}
			if (num3 == 0)
			{
				goto L_01DB;
 
			}
			builder3 = new StringBuilder(49);
			builder4 = new StringBuilder(num3);
			num7 = 0;
			goto L_0193;
 
			L_0119:
				if (num7 < num3)
				{
					num8 = input.ReadByte();
					builder3.Append(num8.ToString("X2"));
					if (num7 != 7)
					{
						builder3.Append(32);
 
					}
					else
					{
						builder3.Append(" ");
 
					}
					if ((num8 >= 32) && (num8 < 128))
					{
						builder4.Append(((ushort) num8));
						goto L_018D;
 
					}
					builder4.Append(46);
 
				}
				else
				{
					builder3.Append(" ");
 
				}
 
			L_018D:
				num7 = (num7 + 1);
 
			L_0193:
				if (num7 < 16)
				{
					goto L_0119;
 
				}
			output.Write(num1.ToString("X4"));
			output.Write(" ");
			output.Write(builder3.ToString());
			output.Write(" ");
			output.WriteLine(builder4.ToString());
 
			L_01DB:
				return; 
		}
		
		public static object GetArrayCap(Array array, int index)
		{
			return Utility.GetArrayCap(array, index, null); 
		} 

		public static object GetArrayCap(Array array, int index, object emptyValue)
		{
			if (array.Length > 0)
			{
				if (index < 0)
				{
					index = 0;
 
				}
				else
				{
					if (index >= array.Length)
					{
						index = (array.Length - 1);
 
					}
 
				}
				return array.GetValue(index); 
			}
			return emptyValue; 
		} 

		public static bool InRange(Point3D p1, Point3D p2, int range)
		{
			if (((p1.m_X >= (p2.m_X - range)) && (p1.m_X <= (p2.m_X + range))) && (p1.m_Y >= (p2.m_Y - range)))
			{
				return !(p1.m_Y > (p2.m_Y + range)); 
			}
			return false; 
		} 

		public static int InsensitiveCompare(string first, string second)
		{
			return Insensitive.Compare(first, second); 
		} 

		public static bool InsensitiveStartsWith(string first, string second)
		{
			return Insensitive.StartsWith(first, second); 
		} 

		public static bool InUpdateRange(IPoint2D p1, IPoint2D p2)
		{
			if (((p1.X >= (p2.X - 18)) && (p1.X <= (p2.X + 18))) && (p1.Y >= (p2.Y - 18)))
			{
				return !(p1.Y > (p2.Y + 18)); 
			}
			return false; 
		} 

		public static bool InUpdateRange(Point2D p1, Point2D p2)
		{
			if (((p1.m_X >= (p2.m_X - 18)) && (p1.m_X <= (p2.m_X + 18))) && (p1.m_Y >= (p2.m_Y - 18)))
			{
				return !(p1.m_Y > (p2.m_Y + 18)); 
			}
			return false; 
		} 

		public static bool InUpdateRange(Point3D p1, Point3D p2)
		{
			if (((p1.m_X >= (p2.m_X - 18)) && (p1.m_X <= (p2.m_X + 18))) && (p1.m_Y >= (p2.m_Y - 18)))
			{
				return !(p1.m_Y > (p2.m_Y + 18)); 
			}
			return false; 
		} 

		public static bool IPMatch(string val, IPAddress ip)
		{
			bool flag1;
			flag1 = true;
			return Utility.IPMatch(val, ip, &(flag1)); 
		} 

		public static bool IPMatch(string val, IPAddress ip, ref bool valid)
		{
			string[] array1;
			int num1;
			int num2;
			int num3;
			string text1;
			bool flag1;
			int num4;
			int num5;
			int num6;
			char ch1;
			int num7;
			int num8;
			int num9;
			int num10;
			char[] array2;
			valid = 1;
			array2 = new char[1];
			array2[0] = 46;
			array1 = val.Split(array2);
			num1 = 0;
			goto L_0185;
 
			L_0021:
				if (num1 >= array1.Length)
				{
					num2 = 0;
					num3 = 255;
					goto L_0165;
 
				}
			text1 = array1[num1];
			if (text1 == "*")
			{
				num2 = 0;
				num3 = 255;
				goto L_0165;
 
			}
			num2 = 0;
			num3 = 0;
			flag1 = false;
			num4 = 10;
			num5 = 10;
			num6 = 0;
			goto L_0157;
 
			L_006B:
				ch1 = text1.Chars[num6];
			if (ch1 == 63)
			{
				if (!flag1)
				{
					num2 = (num2 * num4);
					num2 = num2;
 
				}
				num3 = (num3 * num5);
				num3 = (num3 + (num5 - 1));
 
			}
			else
			{
				if (ch1 == 45)
				{
					flag1 = true;
					num3 = 0;
					goto L_0151;
 
				}
				if ((ch1 == 120) || (ch1 == 88))
				{
					num4 = 16;
					num5 = 16;
					goto L_0151;
 
				}
				if ((ch1 >= 48) && (ch1 <= 57))
				{
					num7 = (ch1 - 48);
					if (!flag1)
					{
						num2 = (num2 * num4);
						num2 = (num2 + num7);
 
					}
					num3 = (num3 * num5);
					num3 = (num3 + num7);
					goto L_0151;
 
				}
				if ((ch1 >= 97) && (ch1 <= 102))
				{
					num8 = (10 + (ch1 - 97));
					if (!flag1)
					{
						num2 = (num2 * num4);
						num2 = (num2 + num8);
 
					}
					num3 = (num3 * num5);
					num3 = (num3 + num8);
					goto L_0151;
 
				}
				if ((ch1 >= 65) && (ch1 <= 70))
				{
					num9 = (10 + (ch1 - 65));
					if (!flag1)
					{
						num2 = (num2 * num4);
						num2 = (num2 + num9);
 
					}
					num3 = (num3 * num5);
					num3 = (num3 + num9);
					goto L_0151;
 
				}
				valid = 0;
 
			}
 
			L_0151:
				num6 = (num6 + 1);
 
			L_0157:
				if (num6 < text1.Length)
				{
					goto L_006B;
 
				}
 
			L_0165:
				num10 = ((byte) (ip.Address >> ((num1 * 8) & 63)));
			if ((num10 < num2) || (num10 > num3))
			{
				return false; 
			}
			num1 = (num1 + 1);
 
			L_0185:
				if (num1 < 4)
				{
					goto L_0021;
 
				}
			return true; 
		}
		
		public static bool IPMatchClassC(IPAddress ip1, IPAddress ip2)
		{
			return ((ip1.Address & ((long) 16777215)) == (ip2.Address & ((long) 16777215))); 
		} 

		public static bool IsInContact(Tile check, Tile[] tiles)
		{
			int num1;
			int num2;
			int num3;
			Tile tile1;
			num1 = check.Height;
			num2 = check.Z;
			for (num3 = 0; (num3 < tiles.Length); num3 = (num3 + 1))
			{
				tile1 = tiles[num3];
				if (((num2 + num1) > tile1.Z) && (num2 < (tile1.Z + tile1.Height)))
				{
					return true; 
				}
				if ((num1 == 0) && ((tile1.Height == 0) && (num2 == tile1.Z)))
				{
					return true; 
				}
 
			}
			return false; 
		} 

		public static bool IsValidIP(string text)
		{
			bool flag1;
			flag1 = true;
			Utility.IPMatch(text, IPAddress.None, &(flag1));
			return flag1; 
		} 

		public static bool NumberBetween(double num, int bound1, int bound2, double allowance)
		{
			int num1;
			if (bound1 > bound2)
			{
				num1 = bound1;
				bound1 = bound2;
				bound2 = num1;
 
			}
			if (num < (((double) bound2) + allowance))
			{
				return (num > (((double) bound1) - allowance)); 
			}
			return false; 
		} 

		public static int Random(int count)
		{
			return Utility.m_Random.Next(count); 
		} 

		public static int Random(int from, int count)
		{
			if (count == 0)
			{
				return from; 
			}
			if (count > 0)
			{
				return (from + Utility.m_Random.Next(count)); 
			}
			return (from - Utility.m_Random.Next(-count)); 
		} 

		public static int RandomAnimalHue()
		{
			return Utility.Random(2301, 18); 
		} 

		public static int RandomBirdHue()
		{
			return Utility.Random(2101, 30); 
		} 

		public static int RandomBlueHue()
		{
			return Utility.Random(1301, 54); 
		} 

		public static bool RandomBool()
		{
			return (Utility.m_Random.Next(2) == 0); 
		} 

		public static double RandomDouble()
		{
			return Utility.m_Random.NextDouble(); 
		} 

		public static int RandomDyedHue()
		{
			return Utility.Random(2, 1000); 
		} 

		public static int RandomGreenHue()
		{
			return Utility.Random(1401, 54); 
		} 

		public static int RandomHairHue()
		{
			return Utility.Random(1102, 48); 
		} 

		public static int RandomList(params int[] list)
		{
			return list[Utility.m_Random.Next(list.Length)]; 
		} 

		public static int RandomMetalHue()
		{
			return Utility.Random(2401, 30); 
		} 

		public static int RandomMinMax(int min, int max)
		{
			int num1;
			if (min > max)
			{
				num1 = min;
				min = max;
				max = num1;
 
			}
			else
			{
				if (min == max)
				{
					return min; 
				}
 
			}
			return (min + Utility.m_Random.Next(((max - min) + 1))); 
		} 

		public static int RandomNeutralHue()
		{
			return Utility.Random(1801, 108); 
		} 

		public static int RandomNondyedHue()
		{
			int num1;
			num1 = Utility.Random(6);
			switch (num1)
			{
				case 0:
				{
					goto L_0027;
 
				}
				case 1:
				{
					goto L_002D;
 
				}
				case 2:
				{
					goto L_0033;
 
				}
				case 3:
				{
					goto L_0039;
 
				}
				case 4:
				{
					goto L_003F;
 
				}
				case 5:
				{
					goto L_0045;
 
				}
 
			}
			goto L_004B;
 
			L_0027:
				return Utility.RandomPinkHue(); 
			L_002D:
				return Utility.RandomBlueHue(); 
			L_0033:
				return Utility.RandomGreenHue(); 
			L_0039:
				return Utility.RandomOrangeHue(); 
			L_003F:
				return Utility.RandomRedHue(); 
			L_0045:
				return Utility.RandomYellowHue(); 
			L_004B:
				return 0; 
		}

		public static int RandomOrangeHue()
		{
			return Utility.Random(1501, 54); 
		} 

		public static int RandomPinkHue()
		{
			return Utility.Random(1201, 54); 
		} 

		public static int RandomRedHue()
		{
			return Utility.Random(1601, 54); 
		} 

		public static int RandomSkinHue()
		{
			return (Utility.Random(1002, 57) | 32768); 
		} 

		public static int RandomSlimeHue()
		{
			return Utility.Random(2201, 24); 
		} 

		public static int RandomSnakeHue()
		{
			return Utility.Random(2001, 18); 
		} 

		public static int RandomYellowHue()
		{
			return Utility.Random(1701, 54); 
		} 

		public static bool RangeCheck(IPoint2D p1, IPoint2D p2, int range)
		{
			if (((p1.X >= (p2.X - range)) && (p1.X <= (p2.X + range))) && (p1.Y >= (p2.Y - range)))
			{
				return !(p2.Y > (p2.Y + range)); 
			}
			return false; 
		} 

		public static bool ToBoolean(string value)
		{
			bool flag1;
			try
			{
				flag1 = Convert.ToBoolean(value);
 
			}
			catch (object obj1)
			{
				flag1 = false;
 
			}
			return flag1; 
		} 

		public static double ToDouble(string value)
		{
			double num1;
			try
			{
				num1 = Convert.ToDouble(value);
 
			}
			catch (object obj1)
			{
				num1 = 0;
 
			}
			return num1; 
		} 

		public static int ToInt32(string value)
		{
			int num1;
			try
			{
				if (value.StartsWith("0x"))
				{
					num1 = Convert.ToInt32(value.Substring(2), 16);
					goto L_002C;
 
				}
				num1 = Convert.ToInt32(value);
 
			}
			catch (object obj1)
			{
				num1 = 0;
 
			}
 
			L_002C:
				return num1; 
		} 

		public static TimeSpan ToTimeSpan(string value)
		{
			TimeSpan span1;
			try
			{
				span1 = TimeSpan.Parse(value);
 
			}
			catch (object obj1)
			{
				span1 = TimeSpan.Zero;
 
			}
			return span1; 
		} 
		
		public static Encoding UTF8 
		{ 
			get
			{
				if (Utility.m_UTF8 == null)
				{
					Utility.m_UTF8 = new UTF8Encoding(0, 0);
				}
				return Utility.m_UTF8;
			}
		}

		public static Encoding UTF8WithEncoding 
		{ 
			get
			{
				if (Utility.m_UTF8WithEncoding == null)
				{
					Utility.m_UTF8WithEncoding = new UTF8Encoding(1, 0);
				}
				return Utility.m_UTF8WithEncoding;
			}
		}

		private static Random m_Random = new Random();
		private static Encoding m_UTF8;
		private static Encoding m_UTF8WithEncoding;
	} 
}