using System;
using System.IO;
using System.Collections;

using Server.Guilds;

namespace Server 
{
	public class World
	{
		public World() : base()
		{
		}

		public static void AddItem(Item item)
		{
				World.m_Items[item.Serial] = item;
 
		} 

		public static void AddMobile(Mobile m)
		{
				World.m_Mobiles[m.Serial] = m;
 
		} 

		public static void Broadcast(int hue, bool ascii, string text)
		{
				Packet packet1;
			ArrayList list1;
			int num1;
			if (ascii)
			{
				packet1 = new AsciiMessage(Serial.MinusOne, -1, 0, hue, 3, "System", text);
 
			}
			else
			{
					packet1 = new UnicodeMessage(Serial.MinusOne, -1, 0, hue, 3, "ENU", "System", text);
 
			}
			list1 = NetState.Instances;
			for (num1 = 0; (num1 < list1.Count); num1 = (num1 + 1))
			{
				if (((NetState) list1[num1]).Mobile != null)
				{
					((NetState) list1[num1]).Send(packet1);
 
				}
 
			}
 
		} 

		public static void Broadcast(int hue, bool ascii, string format, params object[] args)
		{
				World.Broadcast(hue, ascii, string.Format(format, args));
 
		} 

		public static IEntity FindEntity(Serial serial)
		{
				if (serial.IsItem)
		  {
			  return ((Item) World.m_Items[serial]); 
		  }
			if (serial.IsMobile)
			{
				return ((Mobile) World.m_Mobiles[serial]); 
			}
			return null; 
		} 

		public static Item FindItem(Serial serial)
		{
				return ((Item) World.m_Items[serial]); 
		} 

		public static Mobile FindMobile(Serial serial)
		{
				return ((Mobile) World.m_Mobiles[serial]); 
		} 

		public static void Load()
		{
				DateTime time1;
			int num1;
			int num2;
			int num3;
			int num4;
			object[] array1;
			Type[] array2;
			ArrayList list1;
			ArrayList list2;
			ArrayList list3;
			ArrayList list4;
			FileStream stream1;
			BinaryReader reader1;
			FileStream stream2;
			BinaryReader reader2;
			int num5;
			ArrayList list5;
			int num6;
			string text1;
			Type type1;
			ConstructorInfo info1;
			int num7;
			int num8;
			int num9;
			long num10;
			int num11;
			object[] array3;
			Mobile mobile1;
			ConstructorInfo info2;
			string text2;
			FileStream stream3;
			BinaryReader reader3;
			FileStream stream4;
			BinaryReader reader4;
			int num12;
			ArrayList list6;
			int num13;
			string text3;
			Type type2;
			ConstructorInfo info3;
			int num14;
			int num15;
			int num16;
			long num17;
			int num18;
			object[] array4;
			Item item1;
			ConstructorInfo info4;
			string text4;
			FileStream stream5;
			BinaryReader reader5;
			CreateGuildEventArgs args1;
			int num19;
			int num20;
			long num21;
			int num22;
			BaseGuild guild1;
			FileStream stream6;
			BinaryReader reader6;
			int num23;
			int num24;
			long num25;
			int num26;
			Region region1;
			bool flag1;
			bool flag2;
			bool flag3;
			bool flag4;
			Type type3;
			Serial serial1;
			Exception exception1;
			int num27;
			FileStream stream7;
			BinaryFileReader reader7;
			int num28;
			MobileEntry entry1;
			Mobile mobile2;
			Exception exception2;
			FileStream stream8;
			BinaryFileReader reader8;
			int num29;
			ItemEntry entry2;
			Item item2;
			Exception exception3;
			FileStream stream9;
			BinaryFileReader reader9;
			int num30;
			GuildEntry entry3;
			BaseGuild guild2;
			Exception exception4;
			FileStream stream10;
			BinaryFileReader reader10;
			int num31;
			RegionEntry entry4;
			Region region2;
			Exception exception5;
			int num32;
			int num33;
			int num34;
			object obj1;
			Item item3;
			ArrayList list7;
			Mobile mobile3;
			Type[] array5;
			object[] array6;
			IEnumerator enumerator1;
			IDisposable disposable1;
			TimeSpan span1;
			if (World.m_Loaded)
			{
				return; 
			}
			World.m_Loaded = true;
			World.m_LoadingType = null;
			Console.Write("World: Loading...");
			time1 = DateTime.Now;
			World.m_Loading = true;
			World.m_DeleteList = new ArrayList();
			num1 = 0;
			num2 = 0;
			num3 = 0;
			num4 = 0;
			array1 = new object[1];
			array5 = new Type[1];
			array5[0] = typeof(Serial);
			array2 = array5;
			list1 = new ArrayList();
			list2 = new ArrayList();
			list3 = new ArrayList();
			list4 = new ArrayList();
			if (File.Exists(World.mobIdxPath) && File.Exists(World.mobTdbPath))
			{
				stream1 = new FileStream(World.mobIdxPath, 3, 1, 1);
				try
				{
					reader1 = new BinaryReader(stream1);
					stream2 = new FileStream(World.mobTdbPath, 3, 1, 1);
					try
					{
						reader2 = new BinaryReader(stream2);
						num5 = reader2.ReadInt32();
						list5 = new ArrayList(num5);
						num6 = 0;
						goto L_0192;
 
					L_00E3:
						text1 = reader2.ReadString();
						type1 = ScriptCompiler.FindTypeByFullName(text1);
						if (type1 == null)
						{
							Console.WriteLine("failed");
							Console.WriteLine("Error: Type '{0}' was not found. Delete all of those types? (y/n)", text1);
							if (Console.ReadLine() == "y")
							{
								list5.Add(null);
								Console.Write("World: Loading...");
								goto L_018C;
 
							}
							Console.WriteLine("Types will not be deleted. An exception will be thrown when you press return");
							throw new Exception(string.Format("Bad type '{0}'", text1));
 
						}
						info1 = type1.GetConstructor(array2);
						if (info1 != null)
						{
							array6 = new object[2];
							array6[0] = info1;
							list5.Add(array6);
 
						}
						else
						{
								throw new Exception(string.Format("Type '{0}' does not have a serialization constructor", type1));
 
						}
 
					L_018C:
						num6 = (num6 + 1);
 
					L_0192:
						if (num6 < num5)
						{
							goto L_00E3;
 
						}
						num1 = reader1.ReadInt32();
						World.m_Mobiles = new Hashtable(num1);
						for (num7 = 0; (num7 < num1); num7 = (num7 + 1))
						{
							num8 = reader1.ReadInt32();
							num9 = reader1.ReadInt32();
							num10 = reader1.ReadInt64();
							num11 = reader1.ReadInt32();
							array3 = ((object[]) list5[num8]);
							if (array3 != null)
							{
								mobile1 = null;
								info2 = ((ConstructorInfo) array3[0]);
								text2 = ((string) array3[1]);
								try
								{
									array1[0] = Serial.op_Implicit(num9);
									mobile1 = ((Mobile) info2.Invoke(array1));
 
								}
								catch (object obj2)
								{
  
								}
								if (mobile1 != null)
								{
									list2.Add(new MobileEntry(mobile1, num8, text2, num10, num11));
									World.AddMobile(mobile1);
 
								}
 
							}
 
						}
						goto L_0282;
 
					}
					finally
					{
						if (stream2 != null)
						{
							stream2.Dispose();
 
						}
 
					}
					goto L_0282;
 
				}
				finally
				{
					if (stream1 != null)
					{
						stream1.Dispose();
 
					}
 
				}
 
			}
			World.m_Mobiles = new Hashtable();
 
			L_0282:
				if (File.Exists(World.itemIdxPath) && File.Exists(World.itemTdbPath))
				{
					stream3 = new FileStream(World.itemIdxPath, 3, 1, 1);
					try
					{
						reader3 = new BinaryReader(stream3);
						stream4 = new FileStream(World.itemTdbPath, 3, 1, 1);
						try
						{
							reader4 = new BinaryReader(stream4);
							num12 = reader4.ReadInt32();
							list6 = new ArrayList(num12);
							num13 = 0;
							goto L_039F;
 
						L_02EA:
							text3 = reader4.ReadString();
							type2 = ScriptCompiler.FindTypeByFullName(text3);
							if (type2 == null)
							{
								Console.WriteLine("failed");
								Console.WriteLine("Error: Type '{0}' was not found. Delete all of those types? (y/n)", text3);
								if (Console.ReadLine() == "y")
								{
									list6.Add(null);
									Console.Write("World: Loading...");
									goto L_0399;
 
								}
								Console.WriteLine("Types will not be deleted. An exception will be thrown when you press return");
								throw new Exception(string.Format("Bad type '{0}'", text3));
 
							}
							info3 = type2.GetConstructor(array2);
							if (info3 != null)
							{
								array6 = new object[2];
								array6[0] = info3;
								array6[1] = text3;
								list6.Add(array6);
 
							}
							else
							{
									throw new Exception(string.Format("Type '{0}' does not have a serialization constructor", type2));
 
							}
 
						L_0399:
							num13 = (num13 + 1);
 
						L_039F:
							if (num13 < num12)
							{
								goto L_02EA;
 
							}
							num2 = reader3.ReadInt32();
							World.m_Items = new Hashtable(num2);
							for (num14 = 0; (num14 < num2); num14 = (num14 + 1))
							{
								num15 = reader3.ReadInt32();
								num16 = reader3.ReadInt32();
								num17 = reader3.ReadInt64();
								num18 = reader3.ReadInt32();
								array4 = ((object[]) list6[num15]);
								if (array4 != null)
								{
									item1 = null;
									info4 = ((ConstructorInfo) array4[0]);
									text4 = ((string) array4[1]);
									try
									{
										array1[0] = Serial.op_Implicit(num16);
										item1 = ((Item) info4.Invoke(array1));
 
									}
									catch (object obj3)
									{
  
									}
									if (item1 != null)
									{
										list1.Add(new ItemEntry(item1, num15, text4, num17, num18));
										World.AddItem(item1);
 
									}
 
								}
 
							}
							goto L_048F;
 
						}
						finally
						{
							if (stream4 != null)
							{
								stream4.Dispose();
 
							}
 
						}
						goto L_048F;
 
					}
					finally
					{
						if (stream3 != null)
						{
							stream3.Dispose();
 
						}
 
					}
 
				}
			World.m_Items = new Hashtable();
 
			L_048F:
				if (File.Exists(World.guildIdxPath))
				{
					stream5 = new FileStream(World.guildIdxPath, 3, 1, 1);
					try
					{
						reader5 = new BinaryReader(stream5);
						num3 = reader5.ReadInt32();
						args1 = new CreateGuildEventArgs(-1);
						for (num19 = 0; (num19 < num3); num19 = (num19 + 1))
						{
							reader5.ReadInt32();
							num20 = reader5.ReadInt32();
							num21 = reader5.ReadInt64();
							num22 = reader5.ReadInt32();
							args1.Id = num20;
							guild1 = EventSink.InvokeCreateGuild(args1);
							if (guild1 != null)
							{
								list3.Add(new GuildEntry(guild1, num21, num22));
 
							}
 
						}
 
					}
					finally
					{
						if (stream5 != null)
						{
							stream5.Dispose();
 
						}
 
					}
 
				}
			if (File.Exists(World.regionIdxPath))
			{
				stream6 = new FileStream(World.regionIdxPath, 3, 1, 1);
				try
				{
					reader6 = new BinaryReader(stream6);
					num4 = reader6.ReadInt32();
					for (num23 = 0; (num23 < num4); num23 = (num23 + 1))
					{
						reader6.ReadInt32();
						num24 = reader6.ReadInt32();
						num25 = reader6.ReadInt64();
						num26 = reader6.ReadInt32();
						region1 = Region.FindByUId(num24);
						if (region1 != null)
						{
							list4.Add(new RegionEntry(region1, num25, num26));
							Region.AddRegion(region1);
							num4 = (num4 + 1);
 
						}
 
					}
 
				}
				finally
				{
					if (stream6 != null)
					{
						stream6.Dispose();
 
					}
 
				}
 
			}
			flag1 = false;
			flag2 = false;
			flag3 = false;
			flag4 = false;
			type3 = null;
			serial1 = Serial.Zero;
			exception1 = null;
			num27 = 0;
			if (File.Exists(World.mobBinPath))
			{
				stream7 = new FileStream(World.mobBinPath, 3, 1, 1);
				try
				{
					reader7 = new BinaryFileReader(new BinaryReader(stream7));
					for (num28 = 0; (num28 < list2.Count); num28 = (num28 + 1))
					{
						entry1 = ((MobileEntry) list2[num28]);
						mobile2 = ((Mobile) entry1.Object);
						if (mobile2 != null)
						{
							reader7.Seek(entry1.Position, 0);
							try
							{
								World.m_LoadingType = entry1.TypeName;
								mobile2.Deserialize(reader7);
								if (reader7.Position != (entry1.Position + ((long) entry1.Length)))
								{
									throw new Exception(string.Format("***** Bad serialize on {0} *****", mobile2.GetType()));
 
								}
 
							}
							catch (Exception exception6)
							{
								exception2 = exception6;
								list2.RemoveAt(num28);
								exception1 = exception2;
								flag1 = true;
								type3 = mobile2.GetType();
								num27 = entry1.TypeID;
								serial1 = mobile2.Serial;
								goto L_06F2;
 
							}
 
						}
 
					}
 
				}
				finally
				{
					if (stream7 != null)
					{
						stream7.Dispose();
 
					}
 
				}
 
			}
 
			L_06F2:
				if (!flag1 && File.Exists(World.itemBinPath))
				{
					stream8 = new FileStream(World.itemBinPath, 3, 1, 1);
					try
					{
						reader8 = new BinaryFileReader(new BinaryReader(stream8));
						for (num29 = 0; (num29 < list1.Count); num29 = (num29 + 1))
						{
							entry2 = ((ItemEntry) list1[num29]);
							item2 = ((Item) entry2.Object);
							if (item2 != null)
							{
								reader8.Seek(entry2.Position, 0);
								try
								{
									World.m_LoadingType = entry2.TypeName;
									item2.Deserialize(reader8);
									if (reader8.Position != (entry2.Position + ((long) entry2.Length)))
									{
										throw new Exception(string.Format("***** Bad serialize on {0} *****", item2.GetType()));
 
									}
 
								}
								catch (Exception exception7)
								{
									exception3 = exception7;
									list1.RemoveAt(num29);
									exception1 = exception3;
									flag2 = true;
									type3 = item2.GetType();
									num27 = entry2.TypeID;
									serial1 = item2.Serial;
									goto L_07FA;
 
								}
 
							}
 
						}
 
					}
					finally
					{
						if (stream8 != null)
						{
							stream8.Dispose();
 
						}
 
					}
 
				}
 
			L_07FA:
				World.m_LoadingType = null;
			if ((!flag1 && !flag2) && File.Exists(World.guildBinPath))
			{
				stream9 = new FileStream(World.guildBinPath, 3, 1, 1);
				try
				{
					reader9 = new BinaryFileReader(new BinaryReader(stream9));
					for (num30 = 0; (num30 < list3.Count); num30 = (num30 + 1))
					{
						entry3 = ((GuildEntry) list3[num30]);
						guild2 = ((BaseGuild) entry3.Object);
						if (guild2 != null)
						{
							reader9.Seek(entry3.Position, 0);
							try
							{
								guild2.Deserialize(reader9);
								if (reader9.Position != (entry3.Position + ((long) entry3.Length)))
								{
									throw new Exception(string.Format("***** Bad serialize on Guild {0} *****", guild2.Id));
 
								}
 
							}
							catch (Exception exception8)
							{
								exception4 = exception8;
								list3.RemoveAt(num30);
								exception1 = exception4;
								flag3 = true;
								type3 = typeof(BaseGuild);
								num27 = guild2.Id;
								serial1 = Serial.op_Implicit(guild2.Id);
								goto L_0910;
 
							}
 
						}
 
					}
 
				}
				finally
				{
					if (stream9 != null)
					{
						stream9.Dispose();
 
					}
 
				}
 
			}
 
			L_0910:
				if (!flag1 && (!flag2 && File.Exists(World.regionBinPath)))
				{
					stream10 = new FileStream(World.regionBinPath, 3, 1, 1);
					try
					{
						reader10 = new BinaryFileReader(new BinaryReader(stream10));
						for (num31 = 0; (num31 < list4.Count); num31 = (num31 + 1))
						{
							entry4 = ((RegionEntry) list4[num31]);
							region2 = ((Region) entry4.Object);
							if (region2 != null)
							{
								reader10.Seek(entry4.Position, 0);
								try
								{
									region2.Deserialize(reader10);
									if (reader10.Position != (entry4.Position + ((long) entry4.Length)))
									{
										throw new Exception(string.Format("***** Bad serialize on {0} *****", region2.GetType()));
 
									}
 
								}
								catch (Exception exception9)
								{
									exception5 = exception9;
									list4.RemoveAt(num31);
									exception1 = exception5;
									flag4 = true;
									type3 = region2.GetType();
									num27 = entry4.TypeID;
									serial1 = Serial.op_Implicit(region2.UId);
									goto L_0A1B;
 
								}
 
							}
 
						}
 
					}
					finally
					{
						if (stream10 != null)
						{
							stream10.Dispose();
 
						}
 
					}
 
				}
 
			L_0A1B:
				if (!flag2 && ((!flag1 && !flag3) && !flag4))
				{
					goto L_0BC8;
 
				}
			Console.WriteLine("An error was encountered while loading a saved object");
			Console.WriteLine(" - Type: {0}", type3);
			Console.WriteLine(" - Serial: {0}", serial1);
			Console.WriteLine("Delete the object? (y/n)");
			if (Console.ReadLine() != "y")
			{
				goto L_0B5F;
 
			}
			if ((type3 != typeof(BaseGuild)) && !type3.IsSubclassOf(typeof(Region)))
			{
				Console.WriteLine("Delete all objects of that type? (y/n)");
				if (Console.ReadLine() == "y")
				{
					if (flag1)
					{
						num32 = 0;
						while ((num32 < list2.Count))
						{
							if (((MobileEntry) list2[num32]).TypeID == num27)
							{
								list2.RemoveAt(num32);
 
							}
							else
							{
									num32 = (num32 + 1);
 
							}
 
						}
						goto L_0B2F;
 
					}
					if (flag2)
					{
						num33 = 0;
						while ((num33 < list1.Count))
						{
							if (((ItemEntry) list1[num33]).TypeID == num27)
							{
								list1.RemoveAt(num33);
 
							}
							else
							{
									num33 = (num33 + 1);
 
							}
 
						}
 
					}
 
				}
 
			}
 
			L_0B2F:
				World.SaveIndex(list2, World.mobIdxPath);
			World.SaveIndex(list1, World.itemIdxPath);
			World.SaveIndex(list3, World.guildIdxPath);
			World.SaveIndex(list4, World.regionIdxPath);
 
			L_0B5F:
				Console.WriteLine("After pressing return an exception will be thrown and the server will terminate");
			Console.ReadLine();
			array6 = new object[6];
			array6[0] = flag2;
			array6[1] = flag1;
			array6[2] = flag3;
			array6[3] = flag4;
			array6[4] = type3;
			array6[5] = serial1;
			throw new Exception(string.Format("Load failed (items={0}, mobiles={1}, guilds={2}, regions={3}, type={4}, serial={5})", array6), exception1);
 
			L_0BC8:
				EventSink.InvokeWorldLoad();
			World.m_Loading = false;
			for (num34 = 0; (num34 < World.m_DeleteList.Count); num34 = (num34 + 1))
			{
				obj1 = World.m_DeleteList[num34];
				if ((obj1 as Item) != null)
				{
					((Item) obj1).Delete();
 
				}
				else
				{
						if ((obj1 as Mobile) != null)
				  {
					  ((Mobile) obj1).Delete();
 
				  }
 
				}
 
			}
			enumerator1 = World.m_Items.Values.GetEnumerator();
			try
			{
				while (enumerator1.MoveNext())
				{
					item3 = ((Item) enumerator1.Current);
					if (item3.Parent == null)
					{
						item3.UpdateTotals();
 
					}
 
				}
 
			}
			finally
			{
				disposable1 = (enumerator1 as IDisposable);
				if (disposable1 != null)
				{
					disposable1.Dispose();
 
				}
 
			}
			list7 = new ArrayList(World.m_Mobiles.Values);
			enumerator1 = list7.GetEnumerator();
			try
			{
				while (enumerator1.MoveNext())
				{
					mobile3 = ((Mobile) enumerator1.Current);
					mobile3.ForceRegionReEnter(1);
					mobile3.UpdateTotals();
 
				}
 
			}
			finally
			{
				disposable1 = (enumerator1 as IDisposable);
				if (disposable1 != null)
				{
					disposable1.Dispose();
 
				}
 
			}
			span1 = DateTime.op_Subtraction(DateTime.Now, time1);
			Console.WriteLine("done ({1} items, {2} mobiles) ({0:F1} seconds)", span1.TotalSeconds, World.m_Items.Count, World.m_Mobiles.Count);
 
		}
		
		public static bool OnDelete(object o)
		{
				if (!World.m_Loading)
		  {
			  return true; 
		  }
			World.m_DeleteList.Add(o);
			return false; 
		} 

		public static void RemoveItem(Item item)
		{
				World.m_Items.Remove(item.Serial);
 
		} 

		public static void RemoveMobile(Mobile m)
		{
				World.m_Mobiles.Remove(m.Serial);
 
		} 

		public static void Save()
		{
				World.m_Saves = (World.m_Saves + 1);
			World.Save(1);
 
		} 

		public static void Save(bool message)
		{
				DateTime time1;
			Exception exception1;
			DateTime time2;
			TimeSpan span1;
			object[] array1;
			if (World.m_Saving || (AsyncWriter.ThreadCount > 0))
			{
				return; 
			}
			World.m_Saving = true;
			if (message)
			{
				World.Broadcast(53, 1, "The world is saving, please wait.");
 
			}
			Console.Write("World: Saving...");
			time1 = DateTime.Now;
			if (!Directory.Exists("Saves/Mobiles/"))
			{
				Directory.CreateDirectory("Saves/Mobiles/");
 
			}
			if (!Directory.Exists("Saves/Items/"))
			{
				Directory.CreateDirectory("Saves/Items/");
 
			}
			if (!Directory.Exists("Saves/Guilds/"))
			{
				Directory.CreateDirectory("Saves/Guilds/");
 
			}
			if (!Directory.Exists("Saves/Regions/"))
			{
				Directory.CreateDirectory("Saves/Regions/");
 
			}
			World.SaveMobiles();
			World.SaveItems();
			World.SaveGuilds();
			World.SaveRegions();
			try
			{
				EventSink.InvokeWorldSave(new WorldSaveEventArgs(message));
 
			}
			catch (Exception exception2)
			{
				exception1 = exception2;
				throw new Exception("World Save event threw an exception. Save failed!", exception1);
 
			}
			GC.Collect();
			time2 = DateTime.Now;
			span1 = DateTime.op_Subtraction(time2, time1);
			Console.WriteLine("done in {0:F1} seconds.", span1.TotalSeconds);
			if (message)
			{
				array1 = new object[1];
				span1 = DateTime.op_Subtraction(time2, time1);
				array1[0] = span1.TotalSeconds;
				World.Broadcast(53, 1, "World save complete. The entire process took {0:F1} seconds.", array1);
 
			}
			World.m_Saving = false;
 
		}
		
		private static void SaveGuilds()
		{
				GenericWriter writer1;
			GenericWriter writer2;
			BaseGuild guild1;
			long num1;
			IEnumerator enumerator1;
			IDisposable disposable1;
			if (World.SaveType == 0)
			{
				writer1 = new BinaryFileWriter(World.guildIdxPath, 0);
				writer2 = new BinaryFileWriter(World.guildBinPath, 1);
 
			}
			else
			{
					writer1 = new AsyncWriter(World.guildIdxPath, 0);
				writer2 = new AsyncWriter(World.guildBinPath, 1);
 
			}
			writer1.Write(BaseGuild.List.Count);
			enumerator1 = BaseGuild.List.Values.GetEnumerator();
			try
			{
				while (enumerator1.MoveNext())
				{
					guild1 = ((BaseGuild) enumerator1.Current);
					num1 = writer2.Position;
					writer1.Write(0);
					writer1.Write(guild1.Id);
					writer1.Write(num1);
					guild1.Serialize(writer2);
					writer1.Write(((int) (writer2.Position - num1)));
 
				}
 
			}
			finally
			{
				disposable1 = (enumerator1 as IDisposable);
				if (disposable1 != null)
				{
					disposable1.Dispose();
 
				}
 
			}
			writer1.Close();
			writer2.Close();
 
		} 

		public static void SaveIndex(ArrayList list, string path)
		{
				FileStream stream1;
			BinaryWriter writer1;
			int num1;
			IEntityEntry entry1;
			if (!Directory.Exists("Saves/Mobiles/"))
			{
				Directory.CreateDirectory("Saves/Mobiles/");
 
			}
			if (!Directory.Exists("Saves/Items/"))
			{
				Directory.CreateDirectory("Saves/Items/");
 
			}
			if (!Directory.Exists("Saves/Guilds/"))
			{
				Directory.CreateDirectory("Saves/Guilds/");
 
			}
			if (!Directory.Exists("Saves/Regions/"))
			{
				Directory.CreateDirectory("Saves/Regions/");
 
			}
			stream1 = new FileStream(path, 2, 2, 0);
			try
			{
				writer1 = new BinaryWriter(stream1);
				writer1.Write(list.Count);
				for (num1 = 0; (num1 < list.Count); num1 = (num1 + 1))
				{
					entry1 = ((IEntityEntry) list[num1]);
					writer1.Write(entry1.TypeID);
					writer1.Write(Serial.op_Implicit(entry1.Serial));
					writer1.Write(entry1.Position);
					writer1.Write(entry1.Length);
 
				}
 
			}
			finally
			{
				if (stream1 != null)
				{
					stream1.Dispose();
 
				}
 
			}
 
		} 

		private static void SaveItems()
		{
				ArrayList list1;
			ArrayList list2;
			GenericWriter writer1;
			GenericWriter writer2;
			GenericWriter writer3;
			Item item1;
			Type type1;
			int num1;
			long num2;
			int num3;
			int num4;
			Item item2;
			IEnumerator enumerator1;
			IDisposable disposable1;
			list1 = new ArrayList();
			list2 = new ArrayList(Core.ScriptItems);
			if (World.SaveType == 0)
			{
				writer1 = new BinaryFileWriter(World.itemIdxPath, 0);
				writer2 = new BinaryFileWriter(World.itemTdbPath, 0);
				writer3 = new BinaryFileWriter(World.itemBinPath, 1);
 
			}
			else
			{
					writer1 = new AsyncWriter(World.itemIdxPath, 0);
				writer2 = new AsyncWriter(World.itemTdbPath, 0);
				writer3 = new AsyncWriter(World.itemBinPath, 1);
 
			}
			writer1.Write(World.m_Items.Count);
			enumerator1 = World.m_Items.Values.GetEnumerator();
			try
			{
				while (enumerator1.MoveNext())
				{
					item1 = ((Item) enumerator1.Current);
					if ((item1.Decays && (item1.Parent == null)) && ((item1.Map != Map.Internal) && DateTime.op_LessThanOrEqual(DateTime.op_Addition(item1.LastMoved, item1.DecayTime), DateTime.Now)))
					{
						list1.Add(item1);
 
					}
					type1 = item1.GetType();
					num1 = list2.IndexOf(type1);
					if (num1 == -1)
					{
						num1 = list2.Add(type1);
 
					}
					num2 = writer3.Position;
					writer1.Write(num1);
					writer1.Write(Serial.op_Implicit(item1.Serial));
					writer1.Write(num2);
					item1.Serialize(writer3);
					writer1.Write(((int) (writer3.Position - num2)));
					item1.FreeCache();
 
				}
 
			}
			finally
			{
				disposable1 = (enumerator1 as IDisposable);
				if (disposable1 != null)
				{
					disposable1.Dispose();
 
				}
 
			}
			writer2.Write(list2.Count);
			for (num3 = 0; (num3 < list2.Count); num3 = (num3 + 1))
			{
				writer2.Write(((Type) list2[num3]).FullName);
 
			}
			writer1.Close();
			writer2.Close();
			writer3.Close();
			for (num4 = 0; (num4 < list1.Count); num4 = (num4 + 1))
			{
				item2 = ((Item) list1[num4]);
				if (item2.OnDecay())
				{
					item2.Delete();
 
				}
 
			}
 
		}
		
		private static void SaveMobiles()
		{
				ArrayList list1;
			ArrayList list2;
			GenericWriter writer1;
			GenericWriter writer2;
			GenericWriter writer3;
			Mobile mobile1;
			Type type1;
			int num1;
			long num2;
			int num3;
			int num4;
			IVendor vendor1;
			IEnumerator enumerator1;
			IDisposable disposable1;
			list1 = new ArrayList();
			list2 = new ArrayList(Core.ScriptMobiles);
			if (World.SaveType == 0)
			{
				writer1 = new BinaryFileWriter(World.mobIdxPath, 0);
				writer2 = new BinaryFileWriter(World.mobTdbPath, 0);
				writer3 = new BinaryFileWriter(World.mobBinPath, 1);
 
			}
			else
			{
					writer1 = new AsyncWriter(World.mobIdxPath, 0);
				writer2 = new AsyncWriter(World.mobTdbPath, 0);
				writer3 = new AsyncWriter(World.mobBinPath, 1);
 
			}
			writer1.Write(World.m_Mobiles.Count);
			enumerator1 = World.m_Mobiles.Values.GetEnumerator();
			try
			{
				while (enumerator1.MoveNext())
				{
					mobile1 = ((Mobile) enumerator1.Current);
					type1 = mobile1.GetType();
					num1 = list2.IndexOf(type1);
					if (num1 == -1)
					{
						num1 = list2.Add(type1);
 
					}
					num2 = writer3.Position;
					writer1.Write(num1);
					writer1.Write(Serial.op_Implicit(mobile1.Serial));
					writer1.Write(num2);
					mobile1.Serialize(writer3);
					writer1.Write(((int) (writer3.Position - num2)));
					if (((mobile1 as IVendor) != null) && DateTime.op_LessThan(DateTime.op_Addition(((IVendor) mobile1).LastRestock, ((IVendor) mobile1).RestockDelay), DateTime.Now))
					{
						list1.Add(mobile1);
 
					}
					mobile1.FreeCache();
 
				}
 
			}
			finally
			{
				disposable1 = (enumerator1 as IDisposable);
				if (disposable1 != null)
				{
					disposable1.Dispose();
 
				}
 
			}
			writer2.Write(list2.Count);
			for (num3 = 0; (num3 < list2.Count); num3 = (num3 + 1))
			{
				writer2.Write(((Type) list2[num3]).FullName);
 
			}
			for (num4 = 0; (num4 < list1.Count); num4 = (num4 + 1))
			{
				vendor1 = ((IVendor) list1[num4]);
				vendor1.Restock();
				vendor1.LastRestock = DateTime.Now;
 
			}
			writer1.Close();
			writer2.Close();
			writer3.Close();
 
		} 

		private static void SaveRegions()
		{
				int num1;
			GenericWriter writer1;
			MemoryStream stream1;
			BinaryWriter writer2;
			int num2;
			Region region1;
			long num3;
			AsyncWriter writer3;
			FileStream stream2;
			num1 = 0;
			if (World.SaveType == 0)
			{
				writer1 = new BinaryFileWriter(World.regionBinPath, 1);
 
			}
			else
			{
					writer1 = new AsyncWriter(World.regionBinPath, 1);
 
			}
			stream1 = new MemoryStream((4 + (20 * Region.Regions.Count)));
			writer2 = new BinaryWriter(stream1);
			writer2.Write(0);
			for (num2 = 0; (num2 < Region.Regions.Count); num2 = (num2 + 1))
			{
				region1 = ((Region) Region.Regions[num2]);
				if (region1.Saves)
				{
					num1 = (num1 + 1);
					num3 = writer1.Position;
					writer2.Write(0);
					writer2.Write(region1.UId);
					writer2.Write(num3);
					region1.Serialize(writer1);
					writer2.Write(((int) (writer1.Position - num3)));
 
				}
 
			}
			writer1.Close();
			writer2.Seek(0, 0);
			writer2.Write(num1);
			if (World.SaveType == 1)
			{
				writer3 = new AsyncWriter(World.regionIdxPath, 0);
				writer3.MemStream = stream1;
				writer3.Close();
				return; 
			}
			stream2 = new FileStream(World.regionIdxPath, 2, 2, 0);
			stream1.WriteTo(stream2);
			stream2.Close();
 
		}

		public static Hashtable Items { 
			get
			{
				return World.m_Items;
			}
		}

		public static bool Loaded { 
			get
			{
				return World.m_Loaded;
			}
		}

		public static string LoadingType { 
			get
			{
				return World.m_LoadingType;
			}
		}

		public static Hashtable Mobiles { 
			get
			{
				return World.m_Mobiles;
			}
		}

		public static bool Saving { 
			get
			{
				return World.m_Saving;
			}
		}
		
		private static string guildBinPath = Path.Combine("Saves/Guilds/", "Guilds.bin");
		private static string guildIdxPath = Path.Combine("Saves/Guilds/", "Guilds.idx");
		private static string itemBinPath = Path.Combine("Saves/Items/", "Items.bin");
		private static string itemIdxPath = Path.Combine("Saves/Items/", "Items.idx");
		private static string itemTdbPath = Path.Combine("Saves/Items/", "Items.tdb");
		private static ArrayList m_DeleteList;
		private static Hashtable m_Items;
		private static bool m_Loaded;
		private static bool m_Loading;
		private static string m_LoadingType;
		private static Hashtable m_Mobiles;
		internal static int m_Saves;
		private static bool m_Saving;
		private static string mobBinPath = Path.Combine("Saves/Mobiles/", "Mobiles.bin");
		private static string mobIdxPath = Path.Combine("Saves/Mobiles/", "Mobiles.idx");
		private static string mobTdbPath = Path.Combine("Saves/Mobiles/", "Mobiles.tdb");
		private static string regionBinPath = Path.Combine("Saves/Regions/", "Regions.bin");
		private static string regionIdxPath = Path.Combine("Saves/Regions/", "Regions.idx");
		public static SaveOption SaveType = SaveOption.Normal;

		private sealed class GuildEntry : IEntityEntry
		{
			public GuildEntry(BaseGuild g, long pos, int length) : base()
			{
				this.m_Guild = g;
				this.m_Position = pos;
				this.m_Length = length;
			}
		
			public int Length { 
				get
				{
					return this.m_Length;
				}
			}

			public object Object { 
				get
				{
					return this.m_Guild;
				}
			}

			public long Position { 
				get
				{
					return this.m_Position;
				}
			}

			public Serial Serial { 
				get
				{
					//TRF return Serial.op_Implicit(((this.m_Guild == null) ? 0 : this.m_Guild.Id));
					return ((this.m_Guild == null) ? 0 : this.m_Guild.Id);
				}
			}

			public int TypeID { 
				get
				{
					return 0;
				}
			}
			
			private BaseGuild m_Guild;
			private int m_Length;
			private long m_Position;
 		}

		private interface IEntityEntry
		{
			int Length { get; }
			object Object { get; }
			long Position { get; }
			Serial Serial { get; }
			int TypeID { get; }
 		}

		private sealed class ItemEntry : IEntityEntry
		{
			public ItemEntry(Item item, int typeID, string typeName, long pos, int length) : base()
			{
				this.m_Item = item;
				this.m_TypeID = typeID;
				this.m_TypeName = typeName;
				this.m_Position = pos;
				this.m_Length = length;
			} 
			
			public int Length { 
				get
				{
					return this.m_Length;
				}
			}

			public object Object { 
				get
				{
					return this.m_Item;
				}
			}

			public long Position { 
				get
				{
					return this.m_Position;
				}
			}

			public Serial Serial { 
				get
				{
					if (this.m_Item != null)
					{
						return this.m_Item.Serial; 
					}
					return Serial.MinusOne; 
				}
			}

			public int TypeID { 
				get
				{
					return this.m_TypeID;
				}
			}

			public string TypeName { 
				get
				{
					return this.m_TypeName;
				}
			}
			
			private Item m_Item;
			private int m_Length;
			private long m_Position;
			private int m_TypeID;
			private string m_TypeName;
		}

		private sealed class MobileEntry : IEntityEntry
		{
			public MobileEntry(Mobile mobile, int typeID, string typeName, long pos, int length) : base()
			{
				this.m_Mobile = mobile;
				this.m_TypeID = typeID;
				this.m_TypeName = typeName;
				this.m_Position = pos;
				this.m_Length = length;
			} 
			
			public int Length { 
				get
				{
					return this.m_Length;
				}
			}

			public object Object 
			{ 
				get
				{
					return this.m_Mobile;
				}
			}

			public long Position 
			{ 
				get
				{
					return this.m_Position;
				}
			}

			public Serial Serial 
			{ 
				get
				{
					if (this.m_Mobile != null)
					{
						return this.m_Mobile.Serial; 
					}
					return Serial.MinusOne;
				}
			}

			public int TypeID 
			{ 
				get
				{
					return this.m_TypeID;
				}
			}

			public string TypeName 
			{ 
				get
				{
					return this.m_TypeName;
				}
			}

			private int m_Length;
			private Mobile m_Mobile;
			private long m_Position;
			private int m_TypeID;
			private string m_TypeName;
 		}

		private sealed class RegionEntry : IEntityEntry
		{
			public RegionEntry(Region r, long pos, int length) : base()
			{
				this.m_Region = r;
				this.m_Position = pos;
				this.m_Length = length;
			} 

			public int Length { 
				get
				{
					return this.m_Length;
				}
			}

			public object Object 
			{ 
				get
				{
					return this.m_Region;
				}
			}

			public long Position 
			{ 
				get
				{
					return this.m_Position;
				}
			}

			public Serial Serial 
			{ 
				get
				{
					//TRF return Serial.op_Implicit(((this.m_Region == null) ? 0 : this.m_Region.UId)); 
					return ((this.m_Region == null) ? 0 : this.m_Region.UId); 
				}
			}

			public int TypeID 
			{ 
				get
				{
					return 0;
				}
			}
			
			private int m_Length;
			private long m_Position;
			private Region m_Region;
		}

		public enum SaveOption
		{
			Normal = 0,
			Threaded = 1,
 		}
 	}
}