using System;
using System.Collections;
using System.Net;

using Server.Guilds;

namespace Server
{
	public abstract class GenericReader
	{
		public abstract bool End();
		public abstract bool ReadBool();
		public abstract byte ReadByte();
		public abstract char ReadChar();
		public abstract DateTime ReadDateTime();
		public abstract decimal ReadDecimal();
		public abstract DateTime ReadDeltaTime();
		public abstract double ReadDouble();
		public abstract int ReadEncodedInt();
		public abstract float ReadFloat();
		public abstract BaseGuild ReadGuild();
		public abstract ArrayList ReadGuildList();
		public abstract int ReadInt();
		public abstract IPAddress ReadIPAddress();
		public abstract Item ReadItem();
		public abstract ArrayList ReadItemList();
		public abstract long ReadLong();
		public abstract Map ReadMap();
		public abstract Mobile ReadMobile();
		public abstract ArrayList ReadMobileList();
		public abstract Point2D ReadPoint2D();
		public abstract Point3D ReadPoint3D();
		public abstract Rectangle2D ReadRect2D();
		public abstract sbyte ReadSByte();
		public abstract short ReadShort();
		public abstract string ReadString();
		public abstract TimeSpan ReadTimeSpan();
		public abstract uint ReadUInt();
		public abstract ulong ReadULong();
		public abstract ushort ReadUShort();
	}

	public abstract class GenericWriter
	{
		public GenericWriter() : base()
		{
		}

		public abstract void Close();
		public abstract void Write(BaseGuild value);
		public abstract void Write(bool value);
		public abstract void Write(byte value);
		public abstract void Write(char value);
		public abstract void Write(DateTime value);
		public abstract void Write(decimal value);
		public abstract void Write(double value);
		public abstract void Write(short value);
		public abstract void Write(int value);
		public abstract void Write(long value);
		public abstract void Write(IPAddress value);
		public abstract void Write(Item value);
		public abstract void Write(Map value);
		public abstract void Write(Mobile value);
		public abstract void Write(Point2D value);
		public abstract void Write(Point3D value);
		public abstract void Write(Rectangle2D value);
		public abstract void Write(sbyte value);
		public abstract void Write(float value);
		public abstract void Write(string value);
		public abstract void Write(TimeSpan value);
		public abstract void Write(ushort value);
		public abstract void Write(uint value);
		public abstract void Write(ulong value);
		public abstract void WriteDeltaTime(DateTime value);
		public abstract void WriteEncodedInt(int value);
		public abstract void WriteGuildList(ArrayList list);
		public abstract void WriteGuildList(ArrayList list, bool tidy);
		public abstract void WriteItemList(ArrayList list);
		public abstract void WriteItemList(ArrayList list, bool tidy);
		public abstract void WriteMobileList(ArrayList list);
		public abstract void WriteMobileList(ArrayList list, bool tidy);
		public abstract long Position { get; }
	}
}