using System;

namespace Server 
{
	public enum AccessLevel
	{
		Player = 0,
		Counselor = 1,
		GameMaster = 2,
		Seer = 3,
		Administrator = 4,
	}
 
	public enum ApplyPoisonResult
	{
		Poisoned = 0,
		Immune = 1,
		HigherPoisonActive = 2,
		Cured = 3,
 	}
 
	public enum BodyType
	{
		Empty = 0,
		Monster = 1,
		Sea = 2,
		Animal = 3,
		Human = 4,
		Equipment = 5,
	}
 
	public enum ClientType
	{
		Regular = 0,
		UOTD = 1,
		God = 2,
	}
 
	public enum DeathMoveResult
	{
		MoveToCorpse = 0,
		RemainEquiped = 1,
		MoveToBackpack = 2,
	}
 
	public enum Direction
	{
		North = 0,
		Right = 1,
		East = 2,
		Down = 3,
		South = 4,
		Left = 5,
		West = 6,
		Up = 7,
		Mask = 7,
		Running = 128,
		ValueMask = 135,
	}
 
	public enum EffectLayer
	{
		Head = 0,
		RightHand = 1,
		LeftHand = 2,
		Waist = 3,
		LeftFoot = 4,
		RightFoot = 5,
		CenterFeet = 7,
	}
 
	[FlagsAttribute]
	public enum ItemDelta
	{
		None = 0,
		Update = 1,
		EquipOnly = 2,
		Properties = 4,
	}
 
	public enum Layer
	{
		Invalid = 0,
		FirstValid = 1,
		OneHanded = 1,
		TwoHanded = 2,
		Shoes = 3,
		Pants = 4,
		Shirt = 5,
		Helm = 6,
		Gloves = 7,
		Ring = 8,
		Unused_x9 = 9,
		Neck = 10,
		Hair = 11,
		Waist = 12,
		InnerTorso = 13,
		Bracelet = 14,
		Unused_xF = 15,
		FacialHair = 16,
		MiddleTorso = 17,
		Earrings = 18,
		Arms = 19,
		Cloak = 20,
		Backpack = 21,
		OuterTorso = 22,
		OuterLegs = 23,
		InnerLegs = 24,
		LastUserValid = 24,
		Mount = 25,
		ShopBuy = 26,
		ShopResale = 27,
		ShopSell = 28,
		LastValid = 29,
		Bank = 29,
	}
 
	public enum LightType
	{
		ArchedWindowEast = 0,
		Circle225 = 1,
		Circle150 = 2,
		DoorSouth = 3,
		DoorEast = 4,
		NorthBig = 5,
		NorthEastBig = 6,
		EastBig = 7,
		WestBig = 8,
		SouthWestBig = 9,
		SouthBig = 10,
		NorthSmall = 11,
		NorthEastSmall = 12,
		EastSmall = 13,
		WestSmall = 14,
		SouthSmall = 15,
		DecorationNorth = 16,
		DecorationNorthEast = 17,
		EastTiny = 18,
		DecorationWest = 19,
		DecorationSouthWest = 20,
		SouthTiny = 21,
		RectWindowSouthNoRay = 22,
		RectWindowEastNoRay = 23,
		RectWindowSouth = 24,
		RectWindowEast = 25,
		ArchedWindowSouthNoRay = 26,
		ArchedWindowEastNoRay = 27,
		ArchedWindowSouth = 28,
		Circle300 = 29,
		NorthWestBig = 30,
		DarkSouthEast = 31,
		DarkSouth = 32,
		DarkNorthWest = 33,
		DarkSouthEast2 = 34,
		DarkEast = 35,
		DarkCircle300 = 36,
		DoorOpenSouth = 37,
		DoorOpenEast = 38,
		SquareWindowEast = 39,
		SquareWindowEastNoRay = 40,
		SquareWindowSouth = 41,
		SquareWindowSouthNoRay = 42,
		Empty = 43,
		SkinnyWindowSouthNoRay = 44,
		SkinnyWindowEast = 45,
		SkinnyWindowEastNoRay = 46,
		HoleSouth = 47,
		HoleEast = 48,
		Moongate = 49,
		Strips = 50,
		SmallHoleSouth = 51,
		SmallHoleEast = 52,
		NorthBig2 = 53,
		WestBig2 = 54,
		NorthWestBig2 = 55,
	}
 
	public enum LootType
	{
		Regular = 0,
		Newbied = 1,
		Blessed = 2,
		Cursed = 3,
	}
 
	[FlagsAttribute]
	public enum MapRules
	{
		None = 0,
		Internal = 1,
		FreeMovement = 2,
		BeneficialRestrictions = 4,
		HarmfulRestrictions = 8,

		FeluccaRules = 0,
		TrammelRules = 14,
	}
 
	[FlagsAttribute]
	public enum MobileDelta
	{
		None = 0,
		Name = 1,
		Flags = 2,
		Hits = 4,
		Mana = 8,
		Stam = 16,
		Attributes = 28,
		Stat = 32,
		Noto = 64,
		Gold = 128,
		Weight = 256,
		Direction = 512,
		Hue = 1024,
		Body = 2048,
		Armor = 4096,
		StatCap = 8192,
		GhostUpdate = 16384,
		Followers = 32768,
		Properties = 65536,
		TithingPoints = 131072,
		Resistances = 262144,
		WeaponDamage = 524288,
	}

	public enum MusicName
	{
		OldUlt01 = 0,
		Create1 = 1,
		DragFlit = 2,
		OldUlt02 = 3,
		OldUlt03 = 4,
		OldUlt04 = 5,
		OldUlt05 = 6,
		OldUlt06 = 7,
		Stones2 = 8,
		Britain1 = 9,
		Britain2 = 10,
		Bucsden = 11,
		Jhelom = 12,
		LBCastle = 13,
		Linelle = 14,
		Magincia = 15,
		Minoc = 16,
		Ocllo = 17,
		Samlethe = 18,
		Serpents = 19,
		Skarabra = 20,
		Trinsic = 21,
		Vesper = 22,
		Wind = 23,
		Yew = 24,
		Cave01 = 25,
		Dungeon9 = 26,
		Forest_a = 27,
		InTown01 = 28,
		Jungle_a = 29,
		Mountn_a = 30,
		Plains_a = 31,
		Sailing = 32,
		Swamp_a = 33,
		Tavern01 = 34,
		Tavern02 = 35,
		Tavern03 = 36,
		Tavern04 = 37,
		Combat1 = 38,
		Combat2 = 39,
		Combat3 = 40,
		Approach = 41,
		Death = 42,
		Victory = 43,
		BTCastle = 44,
		Nujelm = 45,
		Dungeon2 = 46,
		Cove = 47,
		Moonglow = 48,

		Invalid = -1,
	}

	public enum ParticleSupportType
	{
		Full = 0,
		Detect = 1,
		None = 2,
	}
 
	public enum ResistanceType
	{
		Physical = 0,
		Fire = 1,
		Cold = 2,
		Poison = 3,
		Energy = 4,
	}
 
	public enum SkillLock
	{
		Up = 0,
		Down = 1,
		Locked = 2,
	}
 
	public enum SkillName
	{
		Alchemy = 0,
		Anatomy = 1,
		AnimalLore = 2,
		ItemID = 3,
		ArmsLore = 4,
		Parry = 5,
		Begging = 6,
		Blacksmith = 7,
		Fletching = 8,
		Peacemaking = 9,
		Camping = 10,
		Carpentry = 11,
		Cartography = 12,
		Cooking = 13,
		DetectHidden = 14,
		Discordance = 15,
		EvalInt = 16,
		Healing = 17,
		Fishing = 18,
		Forensics = 19,
		Herding = 20,
		Hiding = 21,
		Provocation = 22,
		Inscribe = 23,
		Lockpicking = 24,
		Magery = 25,
		MagicResist = 26,
		Tactics = 27,
		Snooping = 28,
		Musicianship = 29,
		Poisoning = 30,
		Archery = 31,
		SpiritSpeak = 32,
		Stealing = 33,
		Tailoring = 34,
		AnimalTaming = 35,
		TasteID = 36,
		Tinkering = 37,
		Tracking = 38,
		Veterinary = 39,
		Swords = 40,
		Macing = 41,
		Fencing = 42,
		Wrestling = 43,
		Lumberjacking = 44,
		Mining = 45,
		Meditation = 46,
		Stealth = 47,
		RemoveTrap = 48,
		Necromancy = 49,
		Focus = 50,
		Chivalry = 51,
	}
 
	public enum StatLockType
	{
		Up = 0,
		Down = 1,
		Locked = 2,
	}
 
	[FlagsAttribute]
	public enum StatType
	{
		Str = 1,
		Dex = 2,
		Int = 4,
		All = 7,
	}
 
	[FlagsAttribute]
	public enum TileFlag
	{
		None = 0,
		Background = 1,
		Weapon = 2,
		Transparent = 4,
		Translucent = 8,
		Wall = 16,
		Damaging = 32,
		Impassable = 64,
		Wet = 128,
		Unknown1 = 256,
		Surface = 512,
		Bridge = 1024,
		Generic = 2048,
		Window = 4096,
		NoShoot = 8192,
		ArticleA = 16384,
		ArticleAn = 32768,
		Internal = 65536,
		Foliage = 131072,
		PartialHue = 262144,
		Unknown2 = 524288,
		Map = 1048576,
		Container = 2097152,
		Wearable = 4194304,
		LightSource = 8388608,
		Animation = 16777216,
		NoDiagonal = 33554432,
		Unknown3 = 67108864,
		Armor = 134217728,
		Roof = 268435456,
		Door = 536870912,
		StairBack = 1073741824,
		StairRight = -2147483648,
	}
 
	public enum TimerPriority
	{
		EveryTick = 0,
		TenMS = 1,
		TwentyFiveMS = 2,
		FiftyMS = 3,
		TwoFiftyMS = 4,
		OneSecond = 5,
		FiveSeconds = 6,
		OneMinute = 7,
	}
 
	public enum VisibleDamageType
	{
		None = 0,
		Related = 1,
		Everyone = 2,
	}
}